 {~ Displays a CCD image from ST7 SBIG camera or a FITS 16-bit image, ~}

program FITSSTVw;
      {edited by David Farinic from some his programme,
      just to show us how VESA extended screen modes can be used.
      Then edited by J.Hollan to reject non-VESA cards
      and to show ST7 CCD images.
      FITS format reading added June 1997 by Jan Hollan.
      An alternative

       BGI SVGA mode added from s7svga draft by Jan Hollan, January 1998 }

 {a draft version giving linear or logarithmic gray scaling}

uses  {standard TP unit:} dos, graph,
      {J.H.'s units:} angles_o, str_num, un_str_m, {g_scree,} ftbridge;

const
h1=
'FITSSTvw <name of image file> [<video mode>]'+cl2+

' displays FITS and ST-7 CCD camera images. Default mode is'+cl+
' standard VGA with 16 steps of gray. Another modes can fail easily:'+cl;
h2=
' SVGA  (using SVGA265.bgi, default autodetect, usually 640*480), or'+cl+
' SVGA# (# can be 320, 640, 800, 1024), or'+cl+
' VESA  (direct VESA instructions)'+cl2;
h3=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;


Type
  Condition = (UNK,Range,Background,Width,Height);
  const LH=16383; li255:longint=255;
Var
  Symb : Condition; Name:string; Value:word;
  Bott_perc,Top_perc,Distrib_b: longint;
  Mean: byte;
  Histogram: array[0..LH] of word;
  Linear:boolean;
  GraphDriver : integer;  { The Graphics device driver }
  GraphMode   : integer;  { The Graphics mode value }
  ErrorCode   : integer;  { Reports any graphics errors }
  MaxColor    : word;     { The maximum color value available }
  OldExitProc : Pointer;  { Saves exit procedure address }
  Palette:PaletteType;
  IntLn:real;
  Lines_64k:byte;
  MaxXp1_d16:byte;
  More_bytes,line_length_byte:word;
  Par:string;
const
 ParamNum:byte=1;
 EGAVGAbgi=1;
 DirectVESA=3; {means not using Graph module and BGI}
 SVGA256bgi=4;
 Distrib: longint=0;
 top: word=255;
 bottom: word=0;
 FitsKind:boolean=false;
 VideoMode:byte=EGAVGAbgi;
 MaxXp1:word=640;
 MaxY:word=479;
 divide_by:byte=1;    {square of this side will be represented by one point}
 SVGAforcedMode:byte=3;  {Forced mode 800*600}
 ForceSVGA:boolean=false;
 FindRange:boolean=true;

  NofCon=5;
  SwitchArray : array[1..NofCon] of string[10] =
   ('UNK','Range','Background','Width','Height');
  CondArray : array[1..NofCon] of Condition =
    (UNK,Range,Background,Width,Height);
  Opened_file:boolean=false;
  compressed:boolean=false;


 {mode=$101;}
 mode=$103;

  offs: word=$A000;
  Rang: word = 255;
  Back: word = 0;
  line_count: word = 1;
  line_length : word = 1;
  JustHelp:boolean=true;

  add_offs: BYTE=0;
var
 stri:string; inh:text;
 m:byte;
 inp: file;
 bufw: FtImLine2Type absolute FtImLine2;
 bufb: array[1..1024] of byte;
 NumRead: integer;
 aux_s:string;


 actupage,  c_line:word;
 granul,d255:byte;
 h,hdiv,w,wdiv,linediv,rest,ww:word;
 RangMul:longint;
 i:integer;
 reg:registers;

procedure Help;
begin write(h1,h2,h3); halt; end;

{Just DirectVESA stuff:}

  procedure  PutPixelMy(xs,ys:word;cc:byte); assembler;
  asm
   mov cx,xs
   mov dx,ys
   push ds
   {mov ax,640d} (*sirka v pixloch obrazovky*)
   mov ax,800d
   mul dx
   add ax,cx
   adc dx,0
   mov w,ax
   cmp actupage,dx
   je @speedup
   mov actupage,dx
          mov   ax, 4F05h
          xor   bx, bx
          mov   cl, granul
          mov   dx, actupage
          shl   dx, cl
          int   10h

   @speedup:
   mov al,cc
   mov bl,al
   mov ax,w
   mov cx,$a000
   mov ds,cx
   mov si,ax
   mov [si],bl
   pop ds
  end;

  procedure Ende (msg: String);
  begin
   asm
    mov ax,3
    int 10h
   end;
   writeln(msg);
   HALT
  end;

  procedure setpal(where:pointer;od,how:word);assembler;
  asm
     pusha
     pushf
     push ds
     mov cx,how
     mov dx,03dah
   @retrace1:
     in  al,dx
     and al,8
     jnz @retrace1
   @retrace2:
     in  al,dx
     and al,8
     jz  @retrace2
   @znova:
     mov dx,03c8h
     mov ax,od
     cli
     out dx,al
     inc dx
     lds si,[where]
     mov ax,cx
     add cx,ax
     add cx,ax
     cld
     rep outsb
     sti
     pop ds
     popf
     popa
  end;

  procedure paletta(bb:byte);
  var
   tempal:array[0..768]of byte;  cc:byte;
  begin
   if bb=0 then
    begin
     Linear:=true;
        for I := 0 to 255 do
         begin
          temPal[I*3] := I shr 2;
          temPal[I*3+1] :=I shr 2;
          temPal[I*3+2] :=I shr 2;
         end
    end
   else
      begin
        Linear:=false;
        IntLn:=ln(255)/62;
        for I := 0 to 255 do
         begin
          cc:=trunc(ln(I+1)/IntLn);
          temPal[I*3] :=cc;
          temPal[I*3+1] :=cc;
          temPal[I*3+2] :=cc;
         end;
      end;
   setpal(addr(tempal),0,256);
  end;

  procedure initvesa;
  begin
   reg.AX := $4F02;
   reg.BX := mode;
   intr($10,reg);
     (*112h-64048016m,101h-640480256,103h-800600256*)
   granul:=4;
   if reg.ax<>$004f then
    begin
     writeln('VESA video mode $',mode,' is not available.');
     halt
    end;
   MaxXp1:=800;
   MaxY:= 599;
 end; {of InitVESA}

{end of DirectVESA stuff}

{Just BGI (instead of DirectVESA) stuff:}
  {$F+}
  procedure MyExitProc;
  begin
    ExitProc := OldExitProc; { Restore exit procedure address }
    CloseGraph;              { Shut down the graphics system }
  end; { MyExitProc }
  {$F-}

  {$F+}
  function DetectSVGA256 : integer;
  { Detects ?VGA or MCGA video cards }
  var
    DetectedDriver : integer;
    SuggestedMode  : integer;
  begin
    DetectGraph(DetectedDriver, SuggestedMode);
    if ForceSVGA then
     DetectSVGA256 := SVGAforcedMode
    else
     case DetectedDriver of
      MCGA:
       DetectSVGA256 := 0;
      VGA:
       DetectSVGA256 := 2;
      else
        DetectSVGA256 := grError; { Couldn't detect hardware }
     end;
  end; { DetectVGA256 }
  {$F-}

  var
    AutoDetectPointer : pointer;

  function Int2Str(L : LongInt) : string;
  { Converts an integer to a string for use with OutText, OutTextXY }
  var
    S : string;
  begin
    Str(L, S);
    Int2Str := S;
  end; { Int2Str }


  procedure Initialize;
  { Initialize graphics and report any errors that may occur }
  var
    InGraphicsMode : boolean; { Flags initialization of graphics mode }
    PathToDriver   : string;  { Stores the DOS path to *.BGI & *.CHR }
  begin
    { when using Crt and graphics, turn off Crt's memory-mapped writes }
  {  DirectVideo := False;}
    OldExitProc := ExitProc;                { save previous exit proc }
    ExitProc := @MyExitProc;                { insert our exit proc in chain }
    PathToDriver := {''}getenv('BGI');
    repeat
     AutoDetectPointer := @DetectSVGA256;   { Point to detection routine }
      GraphDriver := InstallUserDriver('SVGA256', AutoDetectPointer);
      GraphDriver := Detect;
      InitGraph(GraphDriver, GraphMode, PathToDriver);
      ErrorCode := GraphResult;             { preserve error return }
      if ErrorCode <> grOK then             { error? }
      begin
        Writeln('Graphics error: ', GraphErrorMsg(ErrorCode));
        if ErrorCode = grFileNotFound then  { Can't find driver file }
         begin
          Writeln('Enter full path to BGI driver or type <Enter> to quit:');
          Readln(PathToDriver);
          if PathToDriver='' then halt;
          Writeln;
         end
        else
         Halt(1);                          { Some other error: terminate }
      end;
    until ErrorCode = grOK;
    MaxXp1:=(GetMaxX+1);
    MaxY:= GetMaxY;
    MaxColor := GetMaxColor;  { Get the maximum allowable drawing color }
  end; { Initialize }


  procedure Set256Palette(bb:byte);
  type
    RGBColor   = record
                   R, G, B : byte;
                 end;
    VGAPalette = array[0..255] of RGBColor;
  var
    VGAPal   : VGAPalette;
    cc:byte;

  procedure SetDACBlock(Start, Count : integer; var Pal : VGAPalette);
  var
    Regs : Registers;
  begin
    with Regs do
    begin
      AH := $10;
      AL := $12;
      BX := Start;
      CX := Count;
      ES := Seg(Pal);
      DX := Ofs(Pal);
    end;
    Intr($10, Regs);
  end;

  begin
   if bb=0 then
    begin
     Linear:=true;
      for w:=0 to MaxColor do
        with VGAPal[w] do begin R:=w shr 2; G:=w shr 2; B:=w shr 2 end;
    end
   else
      begin
        Linear:=false;
        IntLn:=ln(255)/62;
        for w := 0 to MaxColor do
         begin
          cc:=trunc(ln(w+1)/IntLn);
          with VGAPal[w] do begin R:=cc; G:=cc; B:=cc end;
         end;
      end;
   SetDACBlock(0, 256, VGAPal);
  end; { Set256Palette }

procedure Set16Palette(bb:byte);
var j:byte;
 begin
  if bb=0 then
   begin
    Linear:=true;
     for w:=0 to MaxColor do
      begin
       j:=w*4;
       SetRGBPalette(w,j,j,j);
      end;
   end
  else
     begin
       Linear:=false;
       IntLn:=ln(MaxColor)/(MaxColor*4);
       for w := 0 to MaxColor do
        begin
         j:=trunc(ln(w+1)/IntLn);
         SetRGBPalette(w,j,j,j);
        end;
     end;
  for w:=0 to MaxColor do
   SetPalette(w,w);
  GetPalette(Palette);
 end;

{end of bgi (instead of DirectVESA) stuff}


Procedure ReadSline;
var
 bufcw: FtImLine2Type;
 bufcb: FtImLine1Type absolute bufcw{FtImLine2};
 bufcs: array[1..2048] of shortint absolute bufcw{FtImLine2};
begin
 if FitsKind then
  begin
   if FtReadIm(h,FtImLine1) then
    for w:=1 to Line_length do bufw[w]:=swap(bufw[w]);
  end
 else
    if compressed then
     begin
      BlockRead(inp,c_line,2,NumRead);
      if c_line=line_length_byte then
       BlockRead(inp,bufw,c_line,NumRead)
      else
       begin
        BlockRead(inp,bufcb,c_line,NumRead);
        ww:=1;
        bufw[ww]:=bufcw[ww];
        w:=2;
        while w<c_line do
         begin
          inc(w);inc(ww);
          if bufcb[w]<>128 then
           bufw[ww]:=bufw[ww-1]+bufcs[w]
          else
           begin
            inc(w);
            bufw[ww]:=bufcb[w];
            inc(w);
            bufw[ww]:=bufw[ww]+ bufcb[w] shl 8
           end
         end;
       end
     end
    else
     BlockRead(inp,bufw,line_length,NumRead);
end;

procedure WritePixel(hmin,wmin:word);
 begin
  if FitsKind then
   begin
    hmin:=(hmin * divide_by) - (divide_by-1);
    wmin:=(wmin * divide_by) - (divide_by-1);
    for h:=hmin to hmin+(divide_by -1) do
     begin
      ReadSline;
       for w:=wmin to wmin+(divide_by -1) do
        write(bufw[w]:6);
      writeln;
     end;
    end;
 end;

procedure InitEGAVGAbgi;
var i,j: byte;
  begin
   GraphDriver:=VGA; GraphMode:=VGAHi;
   initgraph(GraphDriver,GraphMode,getenv('BGI'));
   MaxColor:=GetMaxColor;
   Set16Palette(0);
   MaxXp1:=(GetMaxX+1);
   MaxY:= GetMaxY;
   for w:=0 to MaxY  do
    putpixel(w,w,(w mod 256) div 16);
  end;

begin
FillChar(Histogram[0],(LH+1) shl 1,$0);
FileMode:=0;       {Files will be handled READ-ONLY, so even Read-only files
                                                     can be opened}
if ParamCount>0 then
begin
 if (pos('?',paramstr(Paramnum))>0) or (paramstr(1)='--help') then Help;
 if FtInit(paramstr(ParamNum),0) then
  begin
   FitsKind:=true;
   JustHelp:=false;
   line_length:=FtRecl div 2;
   line_count:=FtNuRec;
   inc(ParamNum)
  end
 else
  if rt_reset('',inh,paramstr(ParamNum)) then
   begin
    Opened_file:=true;
    JustHelp:=false;
    inc(ParamNum);
    readln(inh,stri);
    if pos('Compressed',stri)>0 then compressed:=true;
    for i:=2 to 30 do
     begin
      readln(inh,stri);
      h:=pos(' ',stri);
      if h>0 then
       begin
        Name:=copy(stri,1,h-1);
        Symb:=UNK;
        for w:= 1 to NofCon do
         if Name=SwitchArray[w] then Symb:=CondArray[w];
        if Symb<>UNK then
         begin
           Value:=round(
             N_S(copy(stri,pos('=',stri)+2,length(stri)-pos('=',stri)-2)));
           case Symb of
            Range : Rang:=Value;
            Background: Back:=Value;
            Width : line_length:=Value;
            Height : line_count:=Value;
           end;
         end;
       end;
     end;
    close(inh);
   end;
end;


if not (Opened_File or FitsKind) or (paramcount>1) then
 begin
  Par:=__cvtstr(ParamStr(ParamNum),_to_upcase_str);
  if copy(Par,1,4)='SVGA' then
   begin
    ForceSVGA:=true;
    VideoMode:=SVGA256bgi;
    case I_S(copy(Par,5,length(Par)-4)) of
     320: SVGAForcedMode:=0;
     640: SVGAForcedMode:=2;
     800: SVGAForcedMode:=3;
     1024:SVGAForcedMode:=4;
    else
     ForceSVGA:=false;
    end;
   end
  else
  if copy(Par,1,4)='VESA' then
    VideoMode:=DirectVESA;
 end;



{if Back>50 then Back:=Back-50;} {why this?}

if Opened_file and (not FitsKind) then
 begin
  assign(inp,paramstr(1));
  if compressed then
   begin
    reset(inp,1);
    seek(inp,$800);
   end
  else
   begin
    reset(inp,2);
    seek(inp,$400);
   end;
 end;

case VideoMode of
 DirectVESA:
  begin
   initvesa;
   actupage:=0;
   paletta(0);
   for i:=0 to 599  do
    putpixelMy(i,i,i mod 256);
  end;
 SVGA256bgi:
  begin
   Initialize;
   Set256Palette(1);
   for w:=0 to 599  do
    putpixel(w,w,w mod 256);
   setcolor(60);
  end;
 EGAVGAbgi: InitEGAVGAbgi;
end; {of case VideoMode of}


if Opened_file or FitsKind then
 begin
  line_length_byte:=2*line_length;
  if VideoMode=DirectVESA then
   putpixelMy(10,20,0) else putpixel(10,20,0);
   {this sets the UL Corner, or the beginning of VGA graphic memory}
  Lines_64k:=1 + ((1024*64) div MaxXp1);
  More_bytes:=(MaxXp1 - (1024*64 mod MaxXp1)) mod MaxXp1;
  MaxXp1_d16:=MaxXp1 div 16;
  rest:=(MaxXp1 - (add_offs+1)*More_bytes) mod MaxXp1;
  while (Line_length div divide_by) > MaxXp1 do inc(divide_by);
  while (Line_count div divide_by) > MaxY+1 do inc(divide_by);

  if FindRange then
   begin
    for h:=1 to line_count do
     begin
      readSline;
      for w:=1 to line_length do inc(Histogram[bufw[w] shr 2]);
     end;
    Bott_perc:=trunc(0.20*line_count*line_length);
    Top_perc:=trunc(0.9999*line_count*line_length);
    w:=0;
    while bottom=0 do
     begin
      inc(Distrib,Histogram[w]);
      if Distrib>Bott_perc then
       Bottom:=w shl 2;
      inc(w)
     end;
    Distrib_b:=Distrib;
    while (top=255) and (w<LH+1) do
     begin
      inc(Distrib,Histogram[w]);
      if Distrib>=Top_perc then Top:=w shl 2;
      inc(w);
     end;
    rang:=top-bottom;

    if not FitsKind then
     if compressed then
      seek(inp,$800)
     else
      seek(inp,$400);

    (*  If WriteRange then
     begin
     close(inp);
     if rt_reset(inh,paramstr(1)) then
      begin
       Opened_file:=true;
       readln(inh,stri);
       if pos('Compressed',stri)>0 then compressed:=true;
       for i:=2 to 30 do
        begin
         readln(inh,stri);
         h:=pos(' ',stri);
         if h>0 then
          begin
           Name:=copy(stri,1,h-1);
           Symb:=UNK;
           for w:= 1 to NofCon do
            if Name=SwitchArray[w] then Symb:=CondArray[w];
           if Symb<>UNK then
            begin
              Value:=round(
                N_S(copy(stri,pos('=',stri)+2,length(stri)-pos('=',stri)-2)));
              case Symb of
               Range : Rang:=Value;
               Background: Back:=Value;
               Width : line_length:=Value;
               Height : line_count:=Value;
              end;
            end;
          end;
        end;
       close(inh);
      end;
     end;
      *)

   end {of FindRange}
  else
   begin
    Bottom:=Back;
    Top:=bottom+rang;
   end;

  fillchar(bufb,MaxXp1,$0);
  linediv:= 1 + (line_length-1) div divide_by;
  rangmul:=rang * sqr(divide_by);
  d255:=255 div sqr(divide_by);

  for h:=1 to line_count do
   begin
    readSline;

    for w:=1 to line_length do
     begin
      wdiv:= 1 + (w-1) div divide_by;
      if bufw[w]<bottom then {bufb[wdiv]:=0}
      else
       if bufw[w]>top then bufb[wdiv]:=bufb[wdiv] + d255
       else
        bufb[wdiv]:=bufb[wdiv]
          + (li255 * (bufw[w] - bottom) ) div rangmul;
     end;

    if h mod divide_by = 0  then
     begin
      hdiv:= 1 + (h-1) div divide_by;
      if VideoMode=EGAVGAbgi then
       for w:=1 to linediv do
        putpixel(w,hdiv,bufb[w] div 16)
      else
       begin
        if hdiv mod Lines_64k <> 0 then
         begin
          Move(bufb[1], Mem[offs:0], linediv);
          inc(offs,MaxXp1_d16);
         end
        else
         begin
          if More_bytes>0 then      {I'm not sure, if some line is not
                                     overwritten here }
           if rest<=linediv then
            Move(bufb[1], Mem[offs:0], rest)
           else
            Move(bufb[1], Mem[offs:0], linediv);
          if VideoMode=DirectVESA then
           PUTPIXELmy(hdiv,hdiv,1)
          else
           PUTPIXEL(hdiv,hdiv,1);
          OFFS:=$A000;
          if rest<linediv then
           Move(bufb[rest+1], Mem[offs:0], linediv-rest);
          if More_bytes>0 then
           begin
            INC(add_offs, More_bytes div 16 );
            add_offs:=add_offs mod (MaxXp1 div 16);
            rest:=(MaxXp1 -
             (((add_offs div (More_bytes div 16) + 1)*More_bytes) mod MaxXp1)
                 ) mod MaxXp1;
            INC(offs,add_offs);
           end;
         end;
       end;
      fillchar(bufb,MaxXp1,$0);
     end;
   end;

   {WritePixel(x,y);
    (* writes square of words corresponing to the x,y pixel *)
   }

  if FitsKind then FtClose else close(inp);
 end;

if VideoMode<>DirectVESA then
 begin
  settextjustify(righttext,bottomtext);
  outtextxy(MaxXp1-20,MaxY-19,'Hotovo');
 end;

repeat
 Readln(aux_s);
 {if aux_s='p' then prigscrc;}
 if aux_s<>'' then
  if Linear then
   case VideoMode of
    EGAVGAbgi: Set16Palette(1);
    DirectVESA: paletta(1);
   else Set256Palette(1);
   end
  else
   case VideoMode of
    EGAVGAbgi: Set16Palette(0);
    DirectVESA: paletta(0);
   else Set256Palette(0);
   end;
until aux_s='';

if JustHelp then Par:=''
else Par:='Bottom:'+SI(5,Bottom)+'  Range:'+SI(5,Rang);
if VideoMode=DirectVESA then
 ende(Par)
else
 begin
  Closegraph;
  writeln(Par)
end;

If JustHelp then Help
else
{ begin
  w:=bottom;
  Distrib:=Distrib_b;
  for k:=0 to 16 do
   begin
    write(k*15:3);
    for m:=0 to 14 do
     for
        bufb[wdiv]:=bufb[wdiv]
          + (li255*(bufw[w] - bottom)) div rangmul;
     write(Histogram[15*k+m]:5);
    writeln
   end;
  write(255,Histogram[255]:5);
  for m:=1 to 14 do write('  +',m:2);
 end }

end.
