 {~ Draft programme showing a CCD image by ST4 and a MegaStar GSC map~} 

program PCCD1; {from pccde, to show ST4 files}

uses Graph, crt, G_Scree, un_str_m, Precesse, dos ,gcvs, Binaries;

const Loc_GSC: string = 'c:\d\megastar\gsc\';

const cl=#13#10;
h1= cl+
'PCCD1 <RA> <Decl.> <CCD image> [/l# /s# /r# /e# /f# /m /b# /w<output file>]'+cl;
h2=
'   - an ST4 image and star chart from the GSC MegaStar catalogue.'+cl+
'Its parameters are:  '   +cl+
' equatorial coordinates - in degrees  or as <hh:mm:ss.cc> and <deg:'':"">'+cl+
' /l  faintness limit (in decimagnitudes; default 155) '+cl;
h3=
' /s  length of the side of the field (degrees, default 1 degree)'+cl+
' /r  radius of the star at the faintness limit (default 0.3 pixel)'+cl+
' /e  equinox (epoch) of the given coordinates  (default 2000)'+cl+
' /f  minimum radius for writing the faintess (default 4 pixels)'+cl;
h4=
' /m  plots mirror-reversed - RA growing to the right'+cl+
' /b  starts at # per cent from the left side of the screen'+cl+
' /w  writes the stars into a text file.'+cl+
'Instead of       <RA> <Decl.>,      you may give'+cl+
' <variable star name> <Const. short>     or'+cl;
h5=
'                   DB <ADS binary star number>'+cl+
' (provided the corresponding catalogues are available in the needed form).'+cl+
                                                    cl+
' P prints the screen on an Epson printer (<Ctrl><PrntScr> does it as well)'+cl;
h6=
' # writes the screen in the Epson 8-needle 72 DpI format to a file Pgsc.e8'+cl+
'  - the file is either changed, or created in a directory given by the TEMP'+cl+
'  environment variable. The screen is copied to that file as a picture # -'+cl;
h7=
'  then all the screens may be copied to printer by  Copy /b Pgsc.e8 prn.'+cl+
'(Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1994-07-02)';


const         {default values, which can be changed by giving parameters}

WFile :boolean=False; {no output file}
R0 :real=0.3;         {radius for the stars at the Faintness_lim}
Size_in_Dec :real=1;  {side of the field in degrees}
Faintness_Lim :real=155;  {limit set to 155 dmag}
RLim :real=4;        {minimum radius for writing the faintess}
MinX :word=52;        {begin 0 per cent from the left margin}
Mirror :boolean=false;       {Not mirror reversed}

Non_linear:boolean=false;   {Non-linear gray scale}
Low:byte=10;   {Bottom level of the gray 1 to 14 scale - black below}
High:byte=240; {Top      -          "          -         white above}


var buf: array[1..192] of Byte;
   { bufik:string;}
    s_strip:array [1..2048,0..3] of byte;
    s : array [0..3] of byte;
    i,hh,mm,ss,tt,MaxX,MaxY,CenX,CenY,RigX,H: word;
    TextH: byte;
    NoStars : array[0..63] of word;
    Offset : array[0..63] of longint;
    RA_strip_start: array[0..63] of byte;
    N_of_belt, NB,Rel_N_of_field,k,m,NofBelts:byte;
    sig:shortint;
    gd,gm,code,j:integer;
 Scale, RA_beg, Dec_eq_side, RA_Centre, Dec_Centre,
 RA_width, RA_semiwidth, RA_unit,
 RA_point, Dec_point, RA_min, RA_max, F_exp, RA_Scale, RR, CD,
 Year, Aux_r
       : real;
    dir_num, field_num: string[4];
    aux_s: string;
    dir_lett,ch : char;
    inp,inp1:file;
    out,fik:text;
    Around0,Delta_too, File_found: boolean;
    j_min, j_max, j_max_orig : integer;
    V, C: string;
    NoR,NumRead: word;

const {of MegaStar version of the GSC}
 field_count : array[0..11] of byte = (48,47,45,43,40,36,32,27,21,15,9,3);
               {numbers of files in each declination belt}
 Belt_height = 7.5;              {each belt is 7.5 degrees high in declnation}
 Dec_unit = 7.5/(16*1024); {angular unit of declination difference in degrees}

procedure load_image;
var  cc:byte; step,lnlow,intln:real;
begin
 setcolor(15);
 outtextxy(3,MaxY-12,'Press any key to stop loading');
 assign(inp,paramstr(3));
 reset(inp,192);
 for i := 0 to 15 do
  begin
    j:=i*4;
    SetRGBPalette(i,j,j,j);
  end;
  for i:=0 to 15{Palette.Size} do SetPalette(i,i);


 step:=(high-low)/14;
 lnlow:=ln(low);
 intln:=ln(high)-lnlow;
 if step <= 0 then
  begin
   sound(100);
   delay(100);
   nosound;
   exit;
  end;
 if Non_linear then
  for m:=1 to 165 do
   begin
    BlockRead(inp,buf,1,NumRead);
    if keypressed then exit;
    for k:=1 to 192 do
     begin
      if buf[k] > low then
       begin
        if buf[k]>=high then cc:=15
        else cc:= 1+ trunc (14*(ln(Buf[k]) -lnlow)/intln);
        PutPixel(m*2,k*2,cc);
        PutPixel(m*2-1,k*2,cc);
        PutPixel(m*2,k*2-1,cc);
        PutPixel(m*2-1,k*2-1,cc);
       end;
     end
   end
 else
  for m:=1 to 165 do
   begin
    BlockRead(inp,buf,1,NumRead);
    if keypressed then exit;
    for k:=1 to 192 do
     begin
      if buf[k] > low then
       begin
        if buf[k]>=high then cc:=15
        else cc:= 1+trunc((buf[k]-low)/step);
        PutPixel(m*2,k*2,cc);
        PutPixel(m*2-1,k*2,cc);
        PutPixel(m*2,k*2-1,cc);
        PutPixel(m*2-1,k*2-1,cc);
       end;
     end;
  end;


 for i:=0 to 15 do for m:=0 to 10 do for k:=0 to 10 do putpixel(1+11*i+m,386+k,i);

 setcolor(0);
 outtextxy(3,MaxY-12,'Press any key to stop loading');
 setcolor(15);
 BlockRead(inp,buf,1,NumRead);
 H:=round(MaxY*0.83);
 outtextxy(3,H,'Date: ');outtextxy(150,h,'C -Change contrast'); inc(h,texth);
 outtextxy(3,h,'Time: ');outtextxy(150,h,' Low:');inc(h,texth);
 outtextxy(3,h,' exp: ');outtextxy(150,h,'High:');inc(h,texth);
 outtextxy(3,h,'Tele: '); inc(h,texth);
 outtextxy(3,h,' Obs: '); inc(h,texth);

(*setcolor(15);
 closegraph;
 gotoxy(1,10);
 for ii:=1 to 192 do write(chr(buf[ii]));*)

close(inp);
sound(100);
delay(200);
nosound;

end;


Procedure Help;
begin
write(h1);
lowvideo;
write(h2);
write(h3);
write(h4);
write(h5);
write(h6);
write(h7);
halt
end;

Function To_0_360(angle:real):real;
begin
while angle>=360 do angle:=angle-360;
while angle<0 do angle:=angle+360;
To_0_360:=angle
end;



Function RA_count_inc : byte;
begin    {increment of RA is given by the left 5 bites of the third byte}
  RA_count_inc:= s[2] shr 3 ;
end;

Function Dec_count : word;
begin    {Decl. difference from the equatorial side of the field}
  Dec_count:= (s[1] shl 6) + (s[0] shr 2);
end;

Function Plate : byte;
begin
 Plate:= s[2] - ((s[2] shr 3) shl 3)
end;

Function Star_class : byte;
begin
 Star_class:= s[0] - ((s[0] shr 2) shl 2)
end;


procedure description;
var
 aux_str: string [5]; j,R: byte; RR: real; X: word;
begin
H:=TextH;

str(RA_centre:5:2,aux_str);
SetTextJustify(LeftText,CenterText);
outtextxy(RigX+4,H,'R.A.:'); inc(H,TextH);
SetTextJustify(RightText,CenterText);
outtextxy(MaxX-2,H,aux_str); inc(H,TextH+3);

str(Dec_centre:5:2,aux_str);
SetTextJustify(LeftText,CenterText);
outtextxy(RigX+4,H,'Decl.:'); inc(H,TextH);
SetTextJustify(RightText,CenterText);
outtextxy(MaxX-2,H,aux_str);   inc(H,TextH+3);

str(Size_in_Dec:5:3,aux_str);
SetTextJustify(LeftText,CenterText);
outtextxy(RigX+4,H,'Side:');    inc(H,TextH);
SetTextJustify(RightText,CenterText);
outtextxy(MaxX-2,H,aux_str);   inc(H,TextH+3);
outtextxy(MaxX-2,H,'deg');    inc(H,TextH+3);

str(Faintness_lim:3:0,aux_str);
outtextxy(MaxX-2,H,'< '+aux_str);  inc(H,TextH);
outtextxy(MaxX-2,H,'dmag');   inc(H,TextH+5);

X:=RigX +1+ ((MaxX-RigX) div 4);
for j:= 3 to round(Faintness_lim/10) do
 begin
    RR:=exp((Faintness_Lim-j*10)*F_exp)* R0;
           if RR>0.8 then
            begin
             R:=round(RR);
             if R>9 then R:=9;
             circle(X,H,R);
             floodfill(X,H,15);
            end
           else
            if RR>0.4 then
             begin
              for k:=0 to 1 do for m:=0 to k do
              putpixel(X+k,H+m,15);
             end
            else
              putpixel(X,H,15);
      str(j*10:2,aux_str);
      outtextxy(MaxX-2,H,aux_str); inc(H,19)
 end;
SetTextJustify(LeftText,CenterText);
for j:=1 to Paramcount do
 begin
  outtextxy(RigX+4,H,ParamStr(j));  inc(H,TextH)
 end;
end;

Procedure PlotMap;
{just within MinX to RigX - rightmost pixels are reserved for description}
var
 RA_strip, Dec, RA, RA_C : real;
 R,j: byte;
 RA_count : longint;
 XRA, YDec : integer;
 Faintness_str : string[3];

begin
if not File_found then exit;
if (RA_beg>239) and (RA_Centre<120) then RA_C:=RA_centre+360
                                   else RA_C:=RA_centre;
if (RA_beg<119) and (RA_Centre>239) then RA_C:=RA_centre-360;
for j:=j_min to j_max do
 begin
  if keypressed then
   begin
    ch:=readkey;
    if ch=#0 then
     begin
      ch:=readkey;
     end;
    if (ch=#27) or (ch='q') or (ch='Q') or (ch='3') then
     begin
      closegraph;
      if WFile then  close(out);
      halt;
     end
   end;
  RA_strip:= RA_beg + RA_width * j / 64;
  RA_count:=-RA_strip_start[j];
  seek(inp,Offset[j] div 4);
  blockread(inp,s_strip,NoStars[j]);
  for i:= 1 to NoStars[j] do
   begin
    for k:=0 to 3 do s[k]:=s_strip[i,k];
    inc(RA_count,RA_count_inc);
    if s[3]<=Faintness_Lim then
      begin
       RA:=RA_strip + RA_count * RA_unit;
       XRA:= round(CenX + (RA_C-RA)*RA_Scale);
       Dec:=sig*(Dec_eq_side + Dec_count * Dec_unit);
       YDec:= round(CenY + (Dec_Centre-Dec)*Scale);
       if XRA<MinX then exit;
       if (XRA<=RigX) and (YDec>-1) and (YDec<=MaxY) then
         begin
           if Mirror then XRA:=CenX+CenX-XRA;
           if WFile then
            writeln(out,RA:9:5,Dec:9:5,s[3]:4,Plate:2,Star_class:2);
           RR:=exp((Faintness_Lim-s[3])*F_exp)* R0;
           if RR>0.8 then
            begin
             R:=round(RR);
             if R>9 then R:=9;
             circle(XRA,YDec,R);
             floodfill(XRA,YDec,15);
            end
           else
            if RR>0.4 then
             begin
              for k:=0 to 1 do for m:=0 to k do
              putpixel(XRA+k,YDEC+m,15);
             end
            else
              putpixel(XRA,YDEC,15);
           if RR>RLim then
            begin  {faintness in dmag right from the star}
             str(s[3]:2,Faintness_str);
             outtextxy(XRA+R+3,YDEC,Faintness_str)
            end;
         end;
      end;
   end;
 end;
close(inp);
end;

procedure OpenFile(RA,De:real);
begin
N_of_belt:=(trunc(2*abs(De))) div 15;
case N_of_belt of
  0 : dir_num:='0000';
  1 : dir_num:='0730';
  else if odd(N_of_belt) then str((750*N_of_belt)-20:4,dir_num)
                 else str((750*N_of_belt):4,dir_num);
end;
if De<0 then begin dir_lett:='S'; sig:=-1 end
                else begin dir_lett:='N'; sig:=1 end;
               {Sig is +1 for northern and -1 for southern belts}

RA_width:=360/field_count[N_of_belt];
Rel_N_of_field:=trunc(RA / RA_width);
if sig=1 then str(N_of_belt*100+Rel_N_of_field:4,field_num)
         else str(((N_of_belt+12)*100+Rel_N_of_field):4,field_num);
if (Rel_N_of_field<10) and (N_of_belt=0) and (sig=1) then
           field_num:='000'+copy(field_num,4,1);
if (Rel_N_of_field>=10) and (N_of_belt=0) and (sig=1) then
           field_num:='00'+copy(field_num,3,2) ;
if field_num[1]=' ' then field_num:='0'+copy(field_num,2,3);


assign(inp,Loc_GSC+dir_lett+dir_num+'\'+field_num+'.gsc');
{$I-}
reset(inp,4);
if ioresult<>0 then
 begin
  File_found:=false;
  exit
 end
else
 File_found:=true;
{SI+}
for i:= 0 to 63 do
 begin           {reading starts of the 64 meridional strips}
  Blockread(inp,s,1);
  Offset[i]:=s[2]*256+s[1];      {:in two lines, as the right side is to }
  Offset[i]:=Offset[i]*256+s[0]; {: become longint by having a longint member}
  Blockread(inp,s,1);
  RA_strip_start[i]:=s[0];
 end;
for i:=0 to 62 do         {Number of stars in the segment}
 NoStars[i]:=(Offset[i+1]-Offset[i]) div 4 ;
NoStars[63]:=(4*FileSize(inp)-Offset[63]) div 4 ;

Dec_eq_side:=7.5*N_of_belt;  {declination of the side nearer to the equator}
RA_unit:=Dec_unit*(RA_width / 7.5);
RA_beg:=RA_width * Rel_N_of_field ;         {minimum right ascension}

if Around0 then   {RA=0 inside the map}
 if RA_beg>180 then
   begin
    j_min:=trunc((RA_min - RA_beg) / (RA_width /64));
    j_max:=63
   end
  else
   begin
    j_max:=trunc((RA_max - RA_beg)/ (RA_width /64)) +1;
    j_min:=0;
   end

else      {RA zero not inside the map}
 begin
  j_min:=trunc((RA_min - RA_beg) / (RA_width /64));
  j_max:=trunc((RA_max - RA_beg)/ (RA_width /64)) +1;
 end;

if j_min>63 then j_min:=63; if j_min<0 then j_min:=0;
if j_max<0 then j_max:=0; if j_max>63 then j_max:=63;

end;

procedure One_File;
begin
    OpenFile(RA_Point,Dec_Point);
    PlotMap;
end;

procedure SidesOfBelt;
begin
 RA_Point:=RA_centre;
 while j_min=0 do              {to the right from the centre file}
 begin
  RA_point:=To_0_360(RA_point - RA_width);
  One_File;
  if not File_found then exit
 end;

 j_max:=j_max_orig;
 RA_Point:=RA_centre;
 while j_max=63 do             {to the left from the centre file}
 begin
  RA_point:=To_0_360(RA_point + RA_width);
  One_File;
  if not File_found then exit
 end
end;



begin
highvideo;
F_exp:= ln(10)/50; {exponent for computing radii of stars from decimagnitudes}
Delta_too:=true;

if paramcount<3 then help;
val(paramstr(1),ra_centre,code);
if code > 0 then
 begin
  if __2TimeStr(Paramstr(1),hh,mm,ss,tt) then
    ra_centre:=hh*15+mm/4+ss/240+tt/24000
  else
    begin
     C:=paramstr(2);
     V:=paramstr(1);
     if __cvtstr(V,_to_upcase_str)='DB' then
      begin
       if not get_bin(C,RA_centre,Dec_centre,NoR) then
        begin
         writeln(
          'The second parameter denotes no binary within Binaries.dbf');
         help
        end
       else
        if (RA_Centre=0) and (Dec_centre=0) then
         begin
          writeln('The coordinates are not given for this star in Binaries.dbf');
          help
         end
        else
         Delta_too:=false
      end
     else
     if not get_gcvs(V,C,RA_centre,Dec_centre,NoR) then
      begin
        writeln(
'the first parameter is no Right Ascension nor var. star designation!');
        help
      end
     else
      Delta_too:=false
    end
 end;
if RA_centre<0 then RA_centre:=RA_centre+360;

if Delta_too then
begin
 val(paramstr(2),Dec_centre,code);
 if code > 0 then
  begin
   if __2TimeStr(Paramstr(2),hh,mm,ss,tt) then
    Dec_centre:=hh+(mm+(ss+tt/100)/60)/60
   else
    begin
     writeln('the second parameter is no Declination!');
     help
    end
  end
end;

if Paramcount>3 then
 for j:=4 to paramcount do
  begin
   aux_s:=__cvtstr(Paramstr(j),_to_UpCase_Str);
   if (Aux_s[1]='/') or (Aux_s[1]='-') then
   aux_s:=copy(aux_s,2,length(aux_s)-1);
   ch:=aux_s[1];
   aux_s:=copy(aux_s,2,length(aux_s)-1);
   case ch of
   'W':begin
        WFile:=true;
        assign (out,aux_s);
        rewrite(out);
        writeln(out,'RA degrees Decl. dmag Pl Class');
       end;
   'M':Mirror:=true;
   'N':Non_linear:=true;
   else
    begin
     val(Aux_s,Aux_r,code);
     if code > 0 then
      begin
       writeln('the ',ch,' parameter gives no number: ',aux_s);
       help
      end;
     case ch of
        'L': begin
              Faintness_lim:=Aux_r;
              if Faintness_lim<50 then
               begin
                 writeln('Faintness_lim of ',Faintness_lim:3:0,
                 ' dmag is probably an error. Give another number, please:');
                 readln(Faintness_lim)
               end;
              end;
        'S': Size_in_Dec:=aux_r;
        'R': R0:=aux_r;
        'F': RLim:=aux_r;
{        'B': MinX:=round(aux_r);
 }       'T': High:=round(aux_r);
        'B': Low:=round(aux_r);
        'E': begin
              Year:=aux_r;
              if PrecInit(Year,2000) then Precess(RA_centre,Dec_centre);
             end
       end
    end
   end
  end;

detectgraph(gd,gm);
initgraph(gd,gm,GetEnv('BGI'));
MaxX:=GetMaxX; MaxY:=GetMaxY;
if MinX>0 then MinX:=(Succ(MaxX)*MinX) div 100;
RigX:=round((MaxX/639.0) * 600.0)-1; {to be 599 at VGA}
CenX:=MinX+(RigX+1-MinX) div 2;
CenY:=succ(MaxY) div 2;

Scale:= (GetMaxY+1) / Size_in_Dec;
        {vertical number of pixels per VERTICAL side }

CD:=cos(Pi*Dec_centre/180);
RA_min:=To_0_360(RA_centre-1.25*Size_in_Dec/(2*CD));
RA_max:=To_0_360(RA_centre+1.25*Size_in_Dec/(2*CD));
if RA_max > RA_min then Around0:= false else Around0:=true;
RA_Scale:= Scale * CD;

OpenFile(RA_centre,Dec_centre);
j_max_orig:=j_max;

settextstyle(2,HorizDir,4); {LITTle font}
TextH:=TextHeight('Rg')+3;
 line(329,0,329,MaxY); { Limits of CCD picture and its table}
 line(0,385,329,385);
 line(0,MaxY,0,0);
 line(0,0,329,0);
 line(0,MaxY,329,maxy);

line(MinX,0,MaxX,0);        {frame}
line(MinX,MaxY,MaxX,MaxY);
line(MinX,0,MinX,MaxY);
line(RigX,0,RigX,MaxY);
line(CenX -3 ,CenY,CenX +3,CenY);  {center}
line(CenX, CenY -3, CenX, CenY +3);
line(MaxX,0,MaxX,MaxY);
description;

PlotMap;

Dec_Point:=Dec_centre;
SidesOfBelt;


NofBelts:=  (trunc(2*Dec_centre+225       )) div 15
          - (trunc(2*Dec_centre+225 - Size_in_Dec)) div 15;
Dec_point:=3.5 + 7.5*( (trunc(2*Dec_centre)+225 ) div 15 - 15);
if NofBelts>0 then for NB:=1 to NofBelts do     {southwards}
 begin
  Dec_point:=Dec_point -7.5 ;
  OpenFile(RA_centre,Dec_Point);
  j_max_orig:=j_max;
  PlotMap;
  SidesOfBelt;
 end;

NofBelts:=  (trunc(2*Dec_centre+225 + Size_in_Dec)) div 15
          - (trunc(2*Dec_centre+225              )) div 15;
Dec_point:=3.5 + 7.5*( (trunc(2*Dec_centre)+225 ) div 15 - 15);
if NofBelts>0 then for NB:=1 to NofBelts do       {northwards}
 begin
  Dec_point:=Dec_point +7.5 ;
  OpenFile(RA_centre,Dec_Point);
  j_max_orig:=j_max;
  PlotMap;
  SidesOfBelt;
 end;

if WFile then  close(out);
load_image;
(* repeat
   ch:=readkey;
   case ch of
     'c' : begin auto_con; load_image; end;
     end;
until ch = #97;*)

repeat until Keypressed;
ch:=readkey;
if ch=#0 then
 begin
  ch:=readkey;          {PrintScreen}
  if ch=#114 then PriGScrE('',0,9);
 end
else
 if UpCase(ch)='P' then PriGScrE('',0,9)
 else
  begin
   aux_s:=ch;
   val(aux_s,i,j);
   if J=0 then PriGScrE('pgsc',i,9);
  end;

if UpCase(ch)<>'G' then closegraph;

end.
