 {~ Times versus dates, a scale for zenith star maps (Czech, LaTeX) ~}

Program Scale;  {Times versus dates, for star maps by Jan Hollan}
uses solar_ut,angles_o,str_num,
     graph_m8,crt;

var T,LambdD:real; j,k:shortint; DoY:word;
 X,Y,Y1,DY,OneHour,CenX:integer;
 hour:string[2];

procedure help;
  begin
   writeln(cl,'Scale',cl2,
'plots scales (times versus dates) for zenith star maps:'+#13#10+
' parameter is the sidereal time / 1 h.',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
   halt;
  end;

begin
 Draw_Picture_Border:=' ';
 SM:=0;
 if Paramcount>0 then
  if pos('?',paramstr(1))=0 then
   SM:=R_S(Paramstr(1))
  else help
 else help;

 LambdD:=15;
 t_UT:=1;

Main_Program:='Scale';
GM_Mode:=2;
hour:=SRe(2,0,sm);
GM_OuFile:='Scale'+hour+'.ltx';
gm_init(71,30);
Y:=MaxY div 2;
CenX:= MaxX div 2;
DY:=MaxY div 20;
Y1:=Y+DY;
OneHour:= MaxX div 20;

gm_outxy(MaxX-OneHour,Y-5*DY,
  {'Pohled nad jih v '+SRe(5,2,SM)+' h hvezdneho casu'}
  'Sky over south in'+SRe(5,2,SM)+' h of sidereal time'
  ,'r',0);

gm_comm(cl+'% Axis:');
gm_line(0+OneHour,Y,MaxX-OneHour,Y);

gm_comm(cl+'% Hour lines and hours:');
gm_line(0+OneHour,Y,MaxX-OneHour,Y);
for j:=-8 to 8 do
 begin
  X:=CenX + j*(OneHour);
  if j<0 then
   hour:=SI(2,round(Bas_Int(j,24)))
  else
   hour:=SI(1,j);
  gm_comm(hour+' h:');
  gm_line(X,Y,X,Y1);
  gm_outxy(X,Y+2*DY,hour,'c',0);
  if j+1<0 then
   hour:=SI(2,round(Bas_Int(j+1,24)))
  else
   hour:=SI(1,j+1);
  gm_outxy(X-16,Y+3*DY,'\it'+hour,'c',0)
 end;

Y1:=Y-DY;

gm_comm(cl+'% Date lines and dates:');
for j:=1 to 12 do
 begin
  gm_comm(SI(2,j)+'.:');
  DoY:=month_begin[j]+15;
  X:=round((OneHour)*(SM_DoY2T(SM,t_UT,LambdD,DoY)));
  if X>12*(OneHour) then X:=X-24*(OneHour);
  if abs(X)<9*(OneHour) then
   gm_outxy(X+ CenX,Y-3*DY,month_cz[j],'c',0);
  for k:=0 to 3 do
   if (k<3) or (month_length[j]>30) then
    begin
     DoY:=month_begin[j]+10*k;
     X:=round((OneHour)*(SM_DoY2T(SM,t_UT,LambdD,DoY)));
     if X>12*(OneHour) then X:=X-24*(OneHour);
     if abs(X)<17*(MaxX div 40) then
      begin
       X:=X + CenX;
       gm_line(X,Y,X,Y1);
       if k<3 then
        if k>0 then
         gm_outxy(X,Y-2*DY,SI(2,1+10*k),'c',0)
        else
         gm_outxy(X,Y-2*DY,'1','c',0)
      end;
    end;
 end;

repeat gm_quit until false;

end.
