 {~ Times versus dates, a scale for zenith star maps (*.eps, vertical) ~}

Program Scale_v; {by Jan Hollan}
uses solar_ut,angles_o,str_num,
     graph_m8,crt,graph;

var T,LambdD:real; j,k:shortint; DoY:word;
 X,Y,X1,DX,OneHour,CenY:integer;
 OldStyle: TextSettingsType;
 hour:string[2];

procedure help;
  begin
   writeln(cl,'Scale_v',cl2,
'plots vertical scales (times versus dates) for zenith star maps:'+#13#10+
' parameter is the sidereal time / 1 h.',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
   halt;
  end;


begin
 Draw_picture_border:=' ';
 SM:=0;
 if Paramcount>0 then
  if pos('?',paramstr(1))=0 then
   SM:=R_S(Paramstr(1))
  else help
 else help;

 LambdD:=15;
 t_UT:=1;

Main_Program:='Scale2';
GM_Mode:={0}3;
hour:=SRe(2,0,sm);
GM_OuFile:='Scale'+hour+'.eps';
gm_init(100,100);
GetTextSettings(OldStyle);
with OldStyle do settextstyle(Font,VertDir,CharSize);
X:=3*TextH;
CenY:= MaxY div 2;
DX:=MaxX div 60;
X1:=X-DX;
OneHour:= MaxY div 20;

gm_line(X,OneHour,X,MaxY-OneHour);
for j:=-8 to 8 do
 begin
  Y:=CenY + j*(OneHour);
  gm_line(X,Y,X1,Y);
  if j<0 then
   gm_outxy(X-3*DX,Y,SI(2,round(Bas_Int(j,24))),'c',-90)
  else
   gm_outxy(X-3*DX,Y,SI(1,j),'c',-90)
 end;
X1:=X+DX;
for j:=1 to 12 do
 begin
  DoY:=month_begin[j]+15;
  Y:=round((OneHour)*(SM_DoY2T(SM,t_UT,LambdD,DoY)));
  if Y>12*(OneHour) then Y:=Y-24*(OneHour);
  if abs(Y)<9*(OneHour) then
   gm_outxy(X+4*DX,Y+CenY,month_en[j],'c',-90);
  for k:=0 to 3 do
   if (k<3) or (month_length[j]>30) then
    begin
     DoY:=month_begin[j]+10*k;
     Y:=round((OneHour)*(SM_DoY2T(SM,t_UT,LambdD,DoY)));
     if Y>12*(OneHour) then Y:=Y-24*(OneHour);
     if abs(Y)<17*(MaxY div 40) then
      begin
       Y:=Y + CenY;
       gm_line(X,Y,X1,Y);
       if k<3 then
        if k>0 then
         gm_outxy(X+2*DX,Y,SI(2,1+10*k),'c',-90)
        else
         gm_outxy(X+2*DX,Y,'1','c',-90)
      end;
    end;
 end;

repeat gm_quit until false;

end.
