{ ~ Positions of Planets (in the old sense of word, including Sun and Moon) ~}

 {illum to be made for any A&H.........}

Program planet; {by Jan Hollan, using a unit by D.Motl}
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses angles_o, str_num, Solar_ut, params, semilog,
     Un_Str_M {instead of unit_str by Blaise Computing},
     planets, {co-written by David Motl}
     precesse; {code by Petr Pravec}
const
ZodiSigns: array[0..11] of string[3] = ('Ari','Tau','Gem','Cnc','Leo','Vir',
                                        'Lib','Sco','Sgr','Cap','Aqr','Psc');
Zodiac: boolean=false;
Kind: byte=2;
Next: word=0;
Step: real=1;
Plan_MJD:string[6]='Planet';
Include_Babylonian: boolean = true;
Time_as_MJD: boolean=false;
Comment_str: string[1]='';
Topocentric:boolean=true;
Explanation:boolean=true;
Just_coord:boolean=false; {just RA and Decl as an input to generating a map}
FirstC:boolean=true;
Planet_Wanted:byte=0; {Sun is default}
Age:boolean=false;
ILL_inst_Faint:boolean=false;
Kind_default:boolean=true;
Horiz_Illum:boolean=true;
HeightSurNorm:real=90;
AzimutSurFromS:real=0;

h1=cl+
'             Coordinates of all (or selected) planets:'+cl+cl+

'Plan dDD[.MM[.YY]] tHH[.MM[.SS]] UT# L# F# K# N# NE NT C#[:#[:#...]]'+cl+cl;
h2=
' D  date (initial value is the current one)'+cl+
' T  time (default is the current one)'+cl+
' UT is the t-UTC difference / 1 h (default 1 from Nov. to March, else 2)'+cl+
' L  is the Longitude of the observing place, default that of '
  +MyLocation_Name+','+cl;
h3=
' F  is the latitude      -               "                -  '+cl+
' F{G|J} forces Gregorian (Julian) dating even outside the standard interval'+cl;
h3a=
' K  the Kind of coordinates to be displayed:'+cl+
'  1  heliocentric ecliptic coordinates'+cl+
'  2  geocentric ecliptic coordinates (default)'+cl+
'  3   -  "  -  equatoreal coordinates'+cl;
h4=
'  4  topocentric horizontal coordinates (azimuth and height)'+cl+
'  5   -  "  -    hour angle and declination'+cl+
' M  express time as MJD (suitable just for a single body)'+cl;
h5=
' N  Next days to be computed (default 0, i.e., just the given moment);'+cl+
' S time step for each new position / 1 day (default 1 day)'+cl+
'    (#h  for # / 1 hour, #m for time step in minutes)'+cl+
' NE do not append Explanation of the columns of the table'+cl;
h6=
' NB do not inlude Babylonian expression of coordinates'+cl+
' NT (for K < 4): not Topocentric Moon, even when over horizon'+cl+
' Z  longitude in Zodiac Signs instead of Babyl. longitudes (just for K=2)'+cl;
h7=
' C write just one RA and Declination (as an input to another programme)'+cl+
' CC<character> Prepend a comment character to non-data lines'+cl;
h8=
' C#[:#...]] compute just planet(s) No # (0: Sun, 1: Mercury, ... 10: Moon)'+cl+
'   (e.g., C0:2:5:10  would compute Sun, Venus, Jupiter and Moon only)'+cl+
' A give Age of Moon instead of its faintness'+cl2;
h8a=
'ZM  give Air Mass instead of Faintness (for k>3, an alternative to ZE)'+cl+
'I   give horiz. Illumination instead. k4 becomes default for ZM and I options'+cl+
'I#:# Illumination of a surface oriented to Azimuth_from_S/1degr.:Height/1degr.'+cl2;
h9=
'(Jan Hollan and David Motl, N.Copernicus Observatory and Planetarium in Brno;'+cl+
' the programme is subject to the GNU General Public License,'+cl+
' see http://www.gnu.org/copyleft,'+cl+
' source code is available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

lab:array[1..5] of string[34]=(
'      longitude       latitude   ',
'      longitude       latitude   ',
'   right ascension   declination ',
'   azimuth from S   angul.height ',
'     hour angle      declination ');
labNB:array[1..5] of string[19]=(
' longit.  latitude ',
' longit.  latitude ',
' R.A.  declination ',
' from S  ang.height',
' h.a.  declination ');
ToDisplay:set of byte = [0,1,2,3,4,5,6,7,8,9,10];
NrDisplay:byte=11;

var
 Name,illum:string;
 l,b,r,lg,bg,rg,f,ls,rs,phase_angle,posi_ang,earth_lat,faintness,
 ra_ENP, decl_ENP: real;
 i,NoBo:byte;
 j : integer;
 Moon_over_hor:boolean;
 AUiER:real;
 WereHeadings,aux_b:boolean;
{PlDisplay:string absolute ToDisplay;}
 Vplane:V3;

 procedure Help;
  begin
   write(h1,h2,h3,hTT,h3a,h4,h0enter);
   cont_or_halt;
   write(h0clear,h5,h6,h7,h8,h_zen_ext,h8a,h_refraction,cl,h9);
   halt
  end;

 procedure am_or_ill_inst_fai;
  var cosAI:real; Vbody:V3;
  begin
   if AM_inst_Faint then    
    faintness:=air_mass
   else
    begin
     if Kind>3 then    
      faintness:=faintness+zenith_extinction*air_mass/100;
     if ILL_inst_Faint then 
      begin
       Illum:='  0     ';
       if Kind>3 then
        if h>0 then
	 begin
	  if horiz_illum then 
           Illum:=DnE(1,sin(deg_to_rad(h))*j0vis*exp(ln(10)*(-faintness)/2.5))
	  else
	   begin
	    P3S_Vector(deg_to_rad(A),deg_to_rad(h),Vbody);
	    cosAI:=scal_prod(Vplane,Vbody);
	    if cosAI>0 then
             Illum:=DnE(1,cosAI*j0vis*exp(ln(10)*(-faintness)/2.5))
	   end     
         end
	else 
       else if Kind>1 then 
         Illum:=DnE(1,j0vis*exp(ln(10)*(-faintness)/2.5));
       if length(Illum)<8 then Illum:=Illum+' ';
       Illum:=' '+Illum;
      end; 	
    end;
  end;

 procedure moon_topoc_perhaps;
  begin
   moon_geo(jd+tt_ut,l,b,r,f);
   LB_RD(l,b,RA,Decl);
   if Topocentric then
    begin
     A:=deg_to_rad(360*SM/24-RA); h:=deg_to_rad(Decl);
     ah_to_td(pi/2-fi,A,h);
     Moon_over_hor:=false;
     if (h>-0.04) or (Kind=4) then
      begin
       Moon_over_hor:=true;
       r:=r-sin(h);
       h:=h - arctan(cos(h)/r);
       if (h>-0.04) and not Just_coord then
        begin
         h:=refract_d(rad_to_deg(h),
          pressure_db_101325,Celsius_temp,Relative_humidity);
         h2air_mass(h);
         h:=deg_to_rad(h);
        end
       else air_mass:=0;
       lg:=A; bg:=h;
       A:=rad_to_deg(A); h:=rad_to_deg(h);
       if A>180 then A:=A-360;
       ah_to_td(-(pi/2-fi),lg,bg);
       lg:=deg_to_rad(360*sm/24)-lg;
       l:=lg;
       b:=bg;
       ra_d2l_b(epsi_rad,l,b);
       l:=rad_to_deg(l);
       b:=rad_to_deg(b);
       RA:=rad_to_deg(lg);
       decl:=rad_to_deg(bg);
      end
    end
   else
    Moon_over_hor:=false;
  end;

 procedure one_day_planets;
  procedure refract_lb;
   begin
    l:=Bas_int(360*SM/24-l,360);
    A:=deg_to_rad(l); h:=deg_to_rad(b);
    ah_to_td(pi/2-fi,A,h);
    if h>-0.04 then
     begin
      h:=refract_d(rad_to_deg(h),
       pressure_db_101325,Celsius_temp,Relative_humidity);
      h2air_mass(h);
      h:=deg_to_rad(h);
     end
    else air_mass:=0;
    case Kind of
     4:
      begin
       A:=rad_to_deg(A);
       l:=A
;
       if l>180 then l:=l-360;
       h:=rad_to_deg(h);
       b:=h;
      end;
     5: if h>-0.04 then
      begin
       l:=A; b:=h;
       ah_to_td(-(pi/2-fi),l,b);
       l:=rad_to_deg(l);
       b:=rad_to_deg(b);
       A:=rad_to_deg(A);
       h:=rad_to_deg(h);
      end;
    end;
   end;

  procedure one_stand_plan;
    begin
     if not (i in ToDisplay) then exit;
     Planet_hel(i,jd+tt_ut,l,b,r,Name);
     if Time_as_MJD then
      write(JD-JD_MJD:8:3)
     else
      write(Name);
     if Kind=1 then
      if Include_Babylonian then
       writeln(':',l:7:2,' = '+deg_to_HM(l),b:7:2,' = '+deg_to_dm(b),r:7:2)
      else
       writeln(' ',l:7:2,                   b:7:2,                   r:7:2)
     else
      begin
       Hel_to_Geo(jd+tt_ut,l,b,r,lg,bg,rg);
       phase_angle:=object_phase_angleD(l,b,lg,bg);
       LB_RD(lg,bg,ra,decl);
       if Kind=2 then
        begin
         l:=lg;
         b:=bg;
        end
       else
        begin
         l:=ra; b:=decl;
         if Kind>3 then Refract_lb;
        end;
       faintness:= planet_faintness(i,phase_angle,r,rg);
       Precess(ra,decl);  {to J2000.0}
       subterr_lat_posi_angD(i,ra,decl,ra_ENP,decl_ENP,posi_ang,earth_lat);
       if i=6 then   {including ring for Saturn}
        begin
         bg:=sin(deg_to_rad(earth_lat));
         faintness:=faintness-2.60*abs(bg)+1.25*sqr(bg);
        end;
       am_or_ill_inst_fai;
       if Include_Babylonian then
        begin
         if Zodiac then
          write(' ',l:7:2,
           ' ',ZodiSigns[trunc(l) div 30], l - 30*(trunc(l) div 30):6:2)
         else
          write(':',l:7:2,' ='+h_min_s(Bas_Int(l,360)/15));
         write(b:7:2,' ='+deg_to_dm(b))
        end
       else
         write(' ',l:7:2,b:7:2);
       if ILL_inst_Faint then
        write(rg:7:2,
               Bas_Int(lg-ls+180,360)-180:5:0,illum,
               earth_lat:6:1, posi_ang:6:1 )
       else
        write(rg:7:2,
               Bas_Int(lg-ls+180,360)-180:5:0,faintness:5:1,
               earth_lat:6:1, posi_ang:6:1 );
       if i in [4,5] then
        begin
         write(subterr_longD(i,1,jd,ra,decl,rg):4:0);
         if i=5 then
          write(subterr_longD(i,2,jd,ra,decl,rg):4:0)
        end
       else write('    ');
       if i in [1..4] then write(phase_angle:5:0);
       writeln;
      end
    end;

  begin
   Planet_hel(3,jd+tt_ut,l,b,r,Name);
   ls:=bas_int(l+180,360);
   rs:=r;
   if (Kind>1) and (0 in ToDisplay) then
    begin
     LB_RD(ls,0,ra,decl);
     if Time_as_MJD then
      write(JD-JD_MJD:8:3)
     else
      write('SUN    ');
     case kind of
      2:  if Include_Babylonian then
           if Zodiac then
            write(' ',l:7:2,
             ' ',ZodiSigns[trunc(l) div 30], l - 30*(trunc(l) div 30):6:2,
             '                ',r:6:2)
           else
            write(':',ls:7:2,' ='+h_min_s(ls/15),'                ',r:6:2)
          else
           write(' ',ls:7:2,                    '        '        ,r:6:2);
      3,4,5:
         begin
          l:=ra; b:=decl;
          if kind>3 then refract_lb;
          if Include_Babylonian then
           write(':',l:7:2,' ='+h_min_s(Bas_Int(l,360)/15),b:7:2,' ='+deg_to_dm(b),r:7:2)
          else
           write(' ',l:7:2,                                b:7:2,                  r:7:2)
         end;
      end;
     faintness:= planet_faintness(10,0,0,r);
     Precess(ra,decl);  {to J2000.0}
     subterr_lat_posi_angD(10,ra,decl,ra_ENP,decl_ENP,posi_ang,earth_lat);
       am_or_ill_inst_fai;
       if ILL_inst_Faint then
        write('     ',
               illum,
               earth_lat:6:1, posi_ang:6:1 )
       else
        write(
 faintness:10:1,
               earth_lat:6:1, posi_ang:6:1 );
     {write(earth_lat:16:1,posi_ang:6:1);}
     writeln(subterr_longD(10,1,jd,ra,decl,r):6:1);
    end;     {of Sun}

   for i:=1 to 2 do one_stand_plan;

   if (Kind=1) and (3 in ToDisplay) then
    begin
      Planet_hel(3,jd+tt_ut,l,b,r,Name);
      write(Name);
      if Include_Babylonian then
       writeln(':',l:7:2,' = '+deg_to_hm(l),' ',b:6:2,' = '+deg_to_dm(b),r:7:2)
      else
       writeln(' ',l:7:2,                       b:6:2,                   r:7:2)
    end;

   for i:=4 to 9 do one_stand_plan;
  end;

 procedure  one_day_moon;
  var earth_long:real;  rAU, rs_moon:real;
  begin
   if not (10 in ToDisplay) then exit;
   moon_topoc_perhaps;
   case kind of
    2:begin
       lg:=l; bg:=b;
      end;
    3:begin
       lg:=RA; bg:=Decl;
      end;
    4:begin
       lg:=A; bg:=h;
      end;
    5:begin
       lg:=Bas_Int(360*SM/24-RA,360);
       bg:=decl;
      end;
   end;
   precess(ra,decl); {to J2000.0}
   earth_long:=subterr_longD(11,1,jd,ra,decl,0);
   subterr_lat_posi_angD(11,ra,decl,ra_ENP,decl_ENP,posi_ang,earth_lat);
   if earth_long>180 then earth_long:=earth_long-360;
   if (NrDisplay>1) or WereHeadings then
    if Age then
     if Include_Babylonian then
      writeln(
      '                                          Ea.R.       old                  col.')
     else
      writeln(
      '                        Ea.R.       old                  col.')
    else
     if Include_Babylonian then
      writeln(
      '                                          Ea.R.                            col.')
     else
      writeln(
      '                        Ea.R.                            col.');
   rAU:=r*Earth_radius_equ/AU;
   phase_angle:=object_phase_angleD(l,b,ls,0);
   phase_angle:=180-phase_angle-
                (rAU/rs)*sin(phase_angle*pi*180);
   rs_moon:=rs+cos(phase_angle)*rAU;
   faintness:= planet_faintness(11,phase_angle,rs_moon,rAU);
   am_or_ill_inst_fai;
   if Include_Babylonian then
    begin
     if Time_as_MJD then
      write(JD-JD_MJD:8:3)
     else
      write('Moon   ');
     if Zodiac then
      write(':',lg:7:2,
       ' ',ZodiSigns[trunc(l) div 30], l - 30*(trunc(l) div 30):6:2)
     else
      write(':',lg:7:2,
       ' ='+h_min_s(Bas_Int(lg,360)/15));
     write(bg:7:2,' ='+deg_to_dm(bg),
      r:6:1,
      Bas_Int(l-ls+180,360)-180:6:0);
     if Age then write(
      Bas_Int(l-ls,360)/360*29.53059:5:1,'d')
     else
      if ILL_inst_Faint then
       write(illum)
      else
       write(faintness:6:1);
     write(earth_lat:5:1,posi_ang:6:1,
      earth_long:5:1,
      Bas_Int(l-ls+rad_to_deg(r*sin(deg_to_rad(l-ls))/(rs*AUiER))
              -90-earth_long,360):6:1
      {,phase_angle:4:0})
    end
   else
    begin
     if Time_as_MJD then
      write(JD-JD_MJD:8:3)
     else
      write('Moon   ');
     write(' ',
     lg:7:2,                                 bg:7:2,
     r:6:1,
     Bas_Int(l-ls+180,360)-180:6:0);
     if Age then write(
      Bas_Int(l-ls,360)/360*29.53059:5:1,'d')
     else
      if ILL_inst_Faint then
       write(illum+' ')
      else
       write(faintness:6:1);
     write(earth_lat:5:1,posi_ang:6:1,
     earth_long:5:1,
     Bas_Int(l-ls+rad_to_deg(r*sin(deg_to_rad(l-ls))/(rs*AUiER))
             -90-earth_long,360):6:1
     {,phase_angle:4:0});
    end;
   {If NrDisplay>2 then} writeln;
   if Moon_over_hor and (Kind<>4) then
    write('    (lunar coordinates are topocentric;  Azimuth = ',A:6:2,',  Height = ',h:6:2,')', cl);
  end;

procedure columns_headings;
var spc:string[2];
begin
if Time_as_MJD then spc:='  ' else spc:='';
if Include_Babylonian then
 write(Comment_str,Plan_MJD+spc+lab[Kind]+'    far ')
else
 write(Comment_str,Plan_MJD+spc+labNB[Kind]+' far');
if Kind>1 then
 if AM_inst_Faint and (Kind>3) then
  write(' L-LS  Air    b   PA  long. PhA')
 else
 if ILL_inst_Faint then 
  if (Kind>3) then
   write(' L-LS  illumin.  b   PA  long. PhA')
  else 
   if (Kind>1) then 
    write(' L-LS   bright    b   PA  long. PhA')
   else
    write(' L-LS faint   b   PA  long. PhA')
 else 
  write(' L-LS faint   b   PA  long. PhA');
if Include_Babylonian then
 write(cl,Comment_str,spc,
  '         ---------------- --------------  -----')
else
 write(cl,Comment_str,spc,
  '       -------- -------  ----');
if Kind>1 then
 begin
 
 if ILL_inst_Faint then
   write(
   ' ----  ------- ----- ----- --- ')
  else
   write(
   ' ---- ----- ---- ----- --- ');
  if 5 in ToDisplay then write('II');
  if Include_Babylonian then
   if Zodiac then
    write(cl,Comment_str,spc,
     '         degrees -in Sign degrees  dd:mm   AU')
   else
    write(cl,Comment_str,spc,
     '         degrees hh:mm:ss degrees  dd:mm   AU')
  else
   write(cl,Comment_str,spc,
  '       degrees  degrees   AU')
 end
else
if Include_Babylonian then
 write(cl,Comment_str,spc,
  '         degrees  hh:mm   degrees  dd:mm   AU')
else
 write(cl,Comment_str,spc,
  '       degrees  degrees   AU');
if Kind>1 then
 begin
  if Include_Babylonian then write(' ');
  if AM_inst_faint and (Kind>3) then
   writeln('  degr. masses   d e g r e e')
  else
 
   if ILL_inst_Faint then 
    if (Kind>3) then
     writeln('  degr.   lux        d e g r e e')
    else 
     if (Kind>1) then 
      writeln('  degr.  lm/m^2      d e g r e e')
     else
      writeln('  degr. mag      d e g r e e')
   else
    writeln('  degr. mag      d e g r e e')
 end
else writeln;
WereHeadings:=true;
end;

begin
AUiER:=149598/6.37814; {Astronomical unit in Earth radii}
if paramcount>0 then for j:= 1 to paramcount do
 begin
  Par:=paramstr(j);
  Par:=__cvtstr(Par,_To_UpCase_Str);
  if (Par[1]='/') or (Par[1]='-') then
    Par:=copy(Par,2,length(par)-1);
  case Par[1] of
   '?','-','H': Help; {- added to respect unix --help even without the help}
   'A': Age:=true;
   'C': if length(Par)>1 then
         case Par[2] of
         'C' : Comment_Str:=Par[3];
         'T': if not par_celtemp then help;
         else
          begin
           ToDisplay:=[];
           NrDisplay:=0;
           Par:=copy(Par,2,length(par)-1);
           NoBo:=ItemCountD(':',Par);
           if NoBo>0 then
            for i:=1 to NoBo do
             begin
              if FirstC then
               begin
                Planet_Wanted:=ss2i(ItemStrD(':',i,Par),1);
                FirstC:=false;
               end;
              ToDisplay:=ToDisplay+[ss2i(ItemStrD(':',i,Par),1)];
              inc(NrDisplay);
             end;
          end
         end
        else
         Just_coord:=true;
   'D': if not Par_Date then help;
   'F': if length(par)>1 then
         case Par[2] of
           'J': ForcedJulian:=true;
           'G': ForcedGregorian:=true;
          else
           if not Par_Fi then help;
         end;
   'I': begin 
         ILL_inst_faint:=true;
 
	 Include_Babylonian:=false; 
	 if ItemCountD(':',Par)>1 then
	  begin
	   Horiz_Illum:=false;
           HeightSurNorm:=R_S(ItemStrD(':',2,Par));
           AzimutSurFromS:=Par2r(ItemStrD(':',1,Par));
	   P3S_Vector(deg_to_rad(AzimutSurFromS),
	              deg_to_rad(HeightSurNorm),
		      Vplane);
          end;		      
	end;
   'K': begin
        Par:=copy(Par,2,length(Par)-1);
        val(Par,Kind,code);
        if code>0 then
         begin
          writeln('The /K parameter is outside [1..5]');
          help
         end
	else Kind_default:=false; 
        end;
   'L': if not Par_Lambda then help;
   'M': Time_as_MJD:=true;
   'N': if length(Par)>1 then
         case Par[2] of
          'T': Topocentric:=false;
          'E': Explanation:=false;
          'B': Include_Babylonian:=false;
          else
           begin
            Par:=copy(Par,2,length(Par)-1);
            val(Par,Next,code);
            if code>0 then
             begin
              writeln('The /N parameter is not a number of days.');
              help
             end;
           end;
         end;
    'P': if not par_relpres then help;
    'R': if not par_relhum then help;
    'S': begin
          if pos('H',Par)>0 then
           Step:=par2r(copy(Par,1,pos('H',Par)-1))/24
          else
           if pos('M',Par)>0 then
            Step:=par2r(copy(Par,1,pos('M',Par)-1))/24/60
           else
            Step:=par2r(Par);
         end;
   'T': if not Par_Time_or_TT then help;
   'U': if not Par_UT then help;
   'Z': if length(Par)>1 then if not par_zenext then help else
        else  Zodiac:=true;
  end; {of case}
 end; {of for}

if Time_as_MJD then Plan_MJD:=' MJD  ';

if Kind_default then 
 if AM_inst_Faint or Ill_inst_faint then
 Kind:=4;
 {both quantities are meaningful for a topocentric case}
 {Illumination could be computed also outside atmosphere, however, 
  say a perpenidicular one, for Kind<4.}
  
 



Get_JD;
if not tt_UT_set then tt_ut:=tt_UTC_in_days(JD);
epsi:=Epsilon(JD); {as both epoch and equinox are instantaneous,
                    not J2000.0}
if not PrecInit(2000+(JD-JD2000)/JulCentury,2000) then halt;
ra_ENP:=0; decl_ENP:=90;
Precess(ra_ENP,decl_ENP);

if Just_coord then
 if Planet_Wanted<>3 then
   begin
    i:=Planet_Wanted;
    case i of
    1,2,4..9:
      begin
       Planet_hel(i,jd+tt_ut,l,b,r,Name);
       Hel_to_Geo(jd+tt_ut,l,b,r,lg,bg,rg);
       LB_RD(lg,bg,ra,decl);
      end;
    10:
      moon_topoc_perhaps;
     0: {Sun}
      begin
       Planet_hel(3,jd+tt_ut,l,b,r,Name);
       LB_RD(l+180,0,ra,decl);
      end;
    end;
    writeln('RA',ra:4:3,' De',decl:4:3);
    halt(1);
   end;

case Kind of
 1: writeln(Comment_str+'Planet heliocentric ecliptic coordinates on');
 2: writeln(Comment_str,'Planet geocentric ecliptic coordinates on');
 3: writeln(Comment_str,'Planet geocentric equatorial coordinates on');
 4,5: begin
     writeln(Comment_str,'Planet topocentric (Long.=',rad_to_deg(Lambda):7:3,
            ', Lat.=',rad_to_deg(Fi):7:3,' degrees)',cl,
            'coordinates on');
     Topocentric:=true;
    end;
end;

If (Kind<>2) and Zodiac then Zodiac:=false;

writeln(Comment_str,yyyy,'-',mm:2,'-',nd:2,'  at ',h_min_s(UT),', expressed in UTC, or');
Name:=__cvtstr(DoW(JD,t_UT,_English),_rem_white_str);
writeln(Comment_str,yyyy,'-',mm:2,'-',nd:2,'  at ',h_min_s(Bas_Int(UT+t_UT,24)),
  '  (',Name,')',cl+Comment_str,
  ' expressed in the used time, which is ',t_UT:5:2,' h ahead of the UTC:'+cl);

writeln(Comment_str+'Julian date : ',JD:13:4,'   Local sidereal time : ',h_min_s(sm));
if tt_UT>0.001 then
 writeln(Comment_str+'Terrestric Time - UT assumed : ',tt_UT*24:6:2,' h',cl)
else
 writeln;

If Time_as_MJD then
 begin
  write('Just planet number ');
  aux_b:=false;
  for i:=0 to 10 do
   if i in ToDisplay then
    begin
     if aux_b then write(', ');
     write(i:2,' ('+__cvtstr(Planet_Names[i],_rem_white_str)+')');
     aux_b:=true;
    end;
  writeln(' is displayed',cl);
 end;

columns_headings;
h:=refract_d(30,pressure_db_101325,Celsius_temp,Relative_humidity);
refract_multiplier_unset:=false;

j:=0;
one_day_planets;

if Kind>1 then one_day_moon;

If Next > 0 then for j:=1 to Next do
 begin
  JD:=JD+step;
  if not tt_ut_set then
   tt_ut:=tt_UTC_in_days(JD);
  SM:=bas_int(SM+24.0657098230*step,24);
  {JD:=JD+1;   this was for step = 1 day
   SM:=SM+0.0657098230;}
  Epsi:=Epsilon(JD);
  if not PrecInit(2000+(JD-JD2000)/JulCentury,2000) then halt;
  ra_ENP:=0; decl_ENP:=90;
  Precess(ra_ENP,decl_ENP);
  Name:=__cvtstr(DoW(JD,t_UT,_English),_rem_white_str);
  if NrDisplay>2 then writeln;
  if Time_as_MJD then
   {writeln(JD-JD_MJD:8:3)}
  else
   writeln(Comment_str,
    yyyy,'-',mm:2,'-',nd:2,'  at ',h_min_s(Bas_Int(UT+t_UT,24)),
    '  (',Name,') of the used time:');
  one_day_planets;
  if (j=Next) and ((NrDisplay>1) or (Next>6)) then
   Columns_headings
  else
   WereHeadings:=false;
  if Kind>1 then one_day_moon;
 end;

if Explanation then
 if Kind=1 then
  writeln(cl+
Comment_str+'   (> far <  means distance of the planet from the Sun)')
 else
  begin
   if NrDisplay<3 then writeln;
   write(
Comment_str+'> far  <  gives distance of the body from the Earth (in Earth radii for Moon),',cl,
Comment_str+'> L-LS <  difference of the ecliptical longitude of the body',cl,
Comment_str+'           from that of the Sun (if positive, the body is east from the Sun),',cl);
   if 10 in ToDisplay then write(
Comment_str+'> old  <  for Moon is  (L-LS / 360 degrees) *  29.53059 days',cl);
if ILL_inst_faint then 
 if Horiz_Illum then 
   write(
Comment_str+'> Illu.<  horizontal direct illumination by the object',cl)
 else
   write(
Comment_str+'> Illu.<  direct ilumination of a surface oriented to:'+cl,
Comment_str+'          azimuth',
 AzimutSurFromS:6:1,' degrees from South, angular height',
 HeightSurNorm:5:1,' degrees'+cl);
   write(
Comment_str+'> b    <  planetographic latitude of the subterrestrial point',cl,
Comment_str+'> PA   <  position angle of the central meridian of the planet',cl,
Comment_str+'> long <  planetographic longitude of the subterrestrial point',cl,
Comment_str+'> PhA  <  "phase angle", i.e., angle Sun-body-Earth.',cl);
   if 5 in ToDisplay then write(
Comment_str+'> (II) <  system II longit. of the central meridian (Jupiter, instead of PhA)',cl);
   if 10 in ToDisplay then write(
Comment_str+'> col. <  for Moon is the so-called colongitudo (its PhA=abs(L-LS))');
  end;
end.
