 {~ Example of precession from B1950 to J2000, for file GCVSred.dbf ~}

program pre_g_BJ; {converts   hhmmss / dd''d   B1950.0 
                           to   millidergees   J2000.0
                   - in this case, in the file GCVSRed.dbf
                  {by Jan Hollan}

uses precesse, DbBridge;
var RA,Decl:real; j,dd:integer; hh,mm,ss,RA_n,Decl_n: byte; NoR:word;
LessPrecDe, LessPrecRA: boolean;
begin
if not DbInit('gcvsred.dbf') then
 begin
  writeln(
'Just an example of a one-purpose precession programme. See the source code.');
  halt;
 end;
RA_n:=DbFieldNum('ALPHA');
Decl_n:=DbFieldNum('DELTA');
if not PrecInit(1950,2000) then halt;
NoR:=1;
while DbRead(NoR,rec) do
 begin
  if NoR mod 100 = 0 then
   write(#13,'Precessing record No.:',NoR:5);
  val(copy(rec[RA_n],1,2),hh,j);
  if not(j>0) then
   begin
    LessPrecDe:=false;
    LessPrecRA:=false;
    val(copy(rec[RA_n],3,2),mm,j);
    val(copy(rec[RA_n],5,2),ss,j);
    if j>0 then LessPrecRA:=true;
    RA:=hh*15+(mm+(ss/60))/4;
    val(copy(rec[Decl_n],1,3),dd,j);
    val(copy(rec[Decl_n],4,2),mm,j);
    val(copy(rec[Decl_n],6,1),ss,j);
    if j>0 then LessPrecDe:=true;
    Decl:=mm/60+ss/600;
    if REC[Decl_n][1]='-' then decl:=dd-Decl else decl:=dd+decl;
    Precess(RA,Decl);
    if LessPrecRA then
     str(round(10*RA):4,rec[RA_n])
    else
     str(round(1E3*RA):6,rec[RA_n]);
    if LessPrecDe then
     str(round(1E2*Decl):5,rec[Decl_n])
    else
     str(round(1E3*Decl):6,rec[Decl_n]);
    if DbWrite(NoR,rec) then;
   end;
  inc(NoR)
 end;
DbClose;
writeln(#13,
'All',NoR:5,' records successfully precessed from B1950.0 to J2000.0');
end.
