 {~ Writes average departures, their standard deviations and changes ~}
 {~ into a list of comparison stars ~}
 {~ and then writes the faintesses into a list of comparisons ~}

program var_dif;  {being developed from August 1997 by Jan Hollan}
uses
 dos,
 DbBridge,un_str_m,str_num,params;

type
 Star_r = record
  name : string[6];
  count : byte;
  sum_av: real;
  change: real;
  sumq_sd:real;
  end;
const
 N_Stars:byte=0;
 StarsDbFile:PathStr='';
 Scale:boolean=false;
var
 Star: array [1..30] of Star_r;
 N_Name,
 N_DarC_DarS,
 N_DarC_DarCC,
 N_Faintness,
 N_Name_S,
 N_Count,
 N_Average,
 N_Stand_Dev,
 N_Change_Av,
 N_V,
 N_B,
 N_B_V,
 N_F_vis,
 N_Aver_AverC,
 i_star,i_param  : byte;
 NoR,N_Rec_Old:word;
 DarC_DarCC:real;
 OK:integer;
 NewStar:boolean;
 ComparDbFile,StarsDbFileStru:PathStr;
 CDir:DirStr;CName:NameStr;CExt:ExtStr;
 Par:string[81];
 ParSw:char;

procedure help(s:string);
 begin
  writeln(s);
  write(
'Var_Dif <DbFile name>'+cl2,

'is a programme for computing faintnesses of comaprison stars',cl,
'(appended to a dBase file, new file is created when not existing)',cl,
'and faintnesses of variable star / darknesses of diffuse object',cl,
'according to each comparison star (written into corresponding field',cl,
'of the input dBase file).',cl2,

'Just the first parameter (input file) is obligatory. In further parameters,'+cl,
'fields can be identified by their names or by ordinal numbers:'+cl2,

' C<comparison field>      (default name is DarC_DarS, default position 2)'+cl,
' N<comparison star name field> (default name is Name, default position 3)'+cl,
' F<faintness field)       (default name is Faintness, default position 4)'+cl,
' D<departure field>       (default name is DarC_DarCC, default position 5)'+cl2,

h0EnterLast);
 cont_or_halt;
 write(cl,

'From the futher options, just one may be present, default is S option:',cl,
' S<output star file name>  (default <DbFileName>+s, as comparison Stars)'+cl,
' T<output scale file name> (default <DbFileName>+t, as scale Transformation)'+cl,
'The T option can serve for finding best numeric values for comparisons',cl+
' described by words rather then numbers,',cl,
' or for getting transformed comparisons from the original ones: e.g.,',cl,
' the original comparison 3 may be in fact 3.2 and 4 may be rather 4.5.',cl,
' In this case, the N switch defines a field of original comparison, not of a',cl,
' name of comparison star, and C defines a working field of tried modified',cl,
' comparison. If the name of the field of original comparison is preceded by',cl,
' - sign, a numeric comparison is assumed and its absolute value is considered',cl,
' (this is to be implemented yet, however).',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
  halt;
 end;

Function FieldNum:byte;
var FielN:byte;
begin
 FielN:=DbFieldNum(Par);
 if FielN=0 then
  FielN:=I_S(Par);
 if not (FielN in [1..DbNuField]) then
  help('There is no field named or numbered >'+Par+'<')
 else
  FieldNum:=FielN;
end;


begin
if paramcount<1 then help('');
ComparDbFile:=paramstr(1);
if not DbInit(ComparDbFile) then
 help('No dBase file >'+ComparDbFile+'< exist.');
N_DarC_DarS:=DbFieldNum('DarC_DarS');
 if N_DarC_DarS=0 then N_DarC_DarS:=2;
N_Name:=DbFieldNum('Name');
 if N_Name=0 then N_Name:=3;
N_Faintness:=DbFieldNum('Faintness');
 if N_Faintness=0 then N_Faintness:=4;
N_DarC_DarCC:=DbFieldNum('DarCC_DarC');
 if N_DarC_DarCC=0 then N_DarC_DarCC:=5;
if paramcount>1 then
for i_param:=2 to paramcount do
 begin
  Par:=paramstr(i_param);
  if Par[1] in ['/','-'] then Par:=copy(Par,2,length(Par)-1);
  ParSw:=UpCase(Par[1]);
  Par:=copy(Par,2,length(Par)-1);
  case ParSw of
   'C': N_DarC_DarS:= FieldNum;
   'D': N_DarC_DarCC:=FieldNum;
   'F': N_Faintness:= FieldNum;
   'N': N_Name:=      FieldNum;
   'O': StarsDbFile:=Par;
   'S': begin StarsDbFile:=Par; Scale:=true; end;
  end;
 end;
if StarsDbFile='' then
 begin
  FSplit(ComparDbFile,CDir,CName,CExt);
  StarsDbFile:=copy(CName,1,6);
  if Scale then
   StarsDbFile:=StarsDbFile+'t'
  else
   StarsDbFile:=StarsDbFile+'s';
  StarsDbFileStru:=StarsDbFile+'_';
 end
else
 begin
  FSplit(StarsDbFile,CDir,CName,CExt);
  StarsDbFileStru:=CDir+copy(CName,1,7)+'_';
 end;

NoR:=1;
while DbRead(NoR,rec) do
 begin
  rec[N_Name]:=__cvtstr(rec[N_Name],_rem_white_str);
  val(__cvtstr(rec[N_DarC_DarCC],_rem_white_str),DarC_DarCC,OK);
  if OK=0 then
   begin
    i_star:=1;
    NewStar:=true;
    if N_stars>0 then
     while NewStar and (i_star<=N_stars) do
      if rec[N_Name]=Star[i_star].name then
       NewStar:=false
      else
       inc(i_star);
    if NewStar then
     begin
      inc(N_Stars);
      i_star:=N_Stars;
      Star[i_star].name:=rec[N_Name];
      Star[i_star].count:=0;
      Star[i_star].sum_av:=0;
      Star[i_star].sumq_sd:=0;
     end;
    inc(Star[i_star].count);
    Star[i_star].sum_av :=Star[i_star].sum_av+DarC_DarCC;
    Star[i_star].sumq_sd:=Star[i_star].sumq_sd+sqr(DarC_DarCC);
   end;
  inc(NoR);
 end;
if N_stars<1 then exit;
for i_star:=1 to N_Stars do
 begin
  Star[i_star].sum_av:= - Star[i_star].sum_av/ Star[i_star].count;
  if Star[i_star].count>1 then
   Star[i_star].sumq_sd:= sqrt((Star[i_star].sumq_sd
                                - sqr(Star[i_star].sum_av)*Star[i_star].count
                                )
                               /(Star[i_star].count-1));
 end;
DbClose;

if DbInit(StarsDbFile) then
 begin
  N_Name_S:=DbFieldNum('Name');
  N_Count:=DbFieldNum('Count');
  N_Average:=DbFieldNum('Average');
  N_Stand_Dev:=DbFieldNum('Stand_Dev');
  N_Change_Av:=DbFieldNum('Change_Av');
  if not Scale then
   begin
    N_V:=DbFieldNum('V');
    N_B:=DbFieldNum('B');
    N_F_vis:=DbFieldNum('F_vis');
   end;
 end
else
 begin
  DbStruDescr(StarsDbFileStru);
  DbDescField('Name'     ,'C',3,6,'Star Name or arbitrary designation','');
   N_Name_S:=DbNuRec;
  DbDescField('Count'    ,'N',3,0,'Number of comparisons','');
   N_Count:=DbNuRec;
  DbDescField('Average'  ,'N',6,2,'Average faintness or darkness','');
   N_Average:=DbNuRec;
  DbDescField('Stand_Dev','C',4,0,'Standard Deviation of it','');
   N_Stand_Dev:=DbNuRec;
  DbDescField('Change_Av','N',5,2,'Change of the Average',
'from the last iteration');
   N_Change_Av:=DbNuRec;
  if not Scale then
   begin
    DbDescField('V        ','C',5,0,'V faintness / 1 mag','');
     N_V:=DbNuRec;
    DbDescField('B        ','C',5,0,'B faintness / 1 mag','');
     N_B:=DbNuRec;
    DbDescField('F_vis     ','C',5,0,'Visual faintness / 1 mag',
'e.g., V + 0.3(B-V) for nearly scotopic vision, V for fotopic vision of stars');
     N_F_vis:=DbNuRec;
   end;
  DbClose;
  if not DbNewFrom(StarsDbFile) then exit;
 end;
N_rec_old:=DbNuRec;
for i_star:=1 to N_stars do
 begin
  Star[i_star].change:=Star[i_star].sum_av;
  if DbRead(N_Rec_Old-N_Stars+i_star,rec) then
   begin
    DbWrNum(N_Change_Av,Star[i_star].sum_av);
    Star[i_star].sum_av:=Star[i_star].sum_av+R_S(rec[N_Average]);
   end
  else
   begin
    rec[N_Change_Av]:='';
    if not Scale then
     begin
      rec[N_V]:='';
      rec[N_B]:='';
      rec[N_F_vis]:='';
    end;
   end;
  rec[N_Name_S]:= Star[i_star].name;
  DbWrNum(N_Count,Star[i_star].count);
  DbWrNum(N_Average,Star[i_star].sum_av);
  if Star[i_star].count>1 then
   str(Star[i_star].sumq_sd:DbInfo[N_Stand_dev].len:2,rec[N_Stand_dev])
  else
   rec[N_Stand_Dev]:='';
  if not DbWrite(0,rec) then exit;
 end;
DbClose;

if not DbInit(ComparDbFile) then exit;
NoR:=1;
while DbRead(NoR,rec) do
 begin
  rec[N_Name]:=__cvtstr(rec[N_Name],_rem_white_str);
  val(__cvtstr(rec[N_DarC_DarS],_rem_white_str),DarC_DarCC,OK);
  if OK=0 then
   begin
    i_star:=1;
    NewStar:=true;
    if N_stars>0 then
     while NewStar and (i_star<=N_stars) do
      if rec[N_Name]=Star[i_star].name then
       NewStar:=false
      else
       inc(i_star);
    if not Scale then
     str(DarC_DarCC+Star[i_star].sum_av:DbInfo[N_faintness].len:2,rec[N_faintness])
    else
     begin
      str(DarC_DarCC+Star[i_star].change:DbInfo[N_DarC_DarS].len:2,rec[N_DarC_DarS]);
      str(R_S(rec[N_faintness])+Star[i_star].change:DbInfo[N_faintness].len:2,rec[N_faintness])
     end;
    if not DbWrite(NoR,rec) then exit;
   end;
  inc(NoR);
 end;
DbClose;
end.
