 {~ Plays a melody from a simple text file (see Melodie.txt) ~}

program Play; {plays a melody from text file, by J.Hollan}
uses crt,
     angles_o,un_str_m,str_num;
const
 tones: array [1..12] of string[3] =
     ('a','ais','h','c','cis','d','dis','e','f','fis','g','gis');
 tones_b: array [1..12] of string[3] =
     ('a','b','ces','c','des','d','es','fes','f','ges','g','as');
 tones_hes: array [1..12] of string[3] =
     ('a','hes','ces','c','des','d','es','fes','f','ges','g','as');
 sound_length:word=400; {initial sound length / 1 ms}
 octave:shortint=1;
var
 mel: text; ht,ln2:real; j,oct:integer; sl:word; dimin,Ind:byte;
 tton:string[3]; ton:integer;
 tim, timo:real;
 lin:string;
procedure help(txt:string);
begin
writeln(cl,
'File ',txt,' not found, give a file name with a melody as a parameter.',cl,
' (See melodie.txt, shipped with the programme, as an example.)',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
halt
end;

procedure One_tone;
begin
 tim:=timo;
 ton:=0;
 for j:=1 to 12 do if tones[j]= tton then ton:=j;
 if ton=0 then
  for j:=1 to 12 do if tones_b[j]= tton then ton:=j;
 if ton=0 then
  if tones_hes[2]= tton then ton:=2;
 if ton>0 then
  begin
   if ton>3 then dimin:=2 else dimin:=1;
   sound(round(440*exp((ton-1+12*(octave-dimin))*ht)));
  end;
 delay(round(sound_length*tim));
 nosound;
end;

begin
ln2:=ln(2);
ht:=ln2/12;
if paramcount<1 then
 begin if not rt_reset('',mel,'melodie.txt') then help('melodie.txt') end
else if pos('?',paramstr(1))>0 then help('') else
 begin if not rt_reset('',mel,paramstr(1)) then help(paramstr(1)) end;
timo:=1;
repeat
 if keypressed then begin nosound; close(mel); halt; end;
 readln(mel,lin);
 lin:=__cvtstr(lin,_rem_white_str);
 if not ((lin[1]='&') or (lin='')) then
  begin
   if ItemCount(lin)>1 then
    begin
     Ind:=1;
     val(ItemStr(Ind,lin),oct,j);
     if j=0 then
      begin
       Inc(Ind);
       octave:=oct;
      end;
     tton:=ItemStr(Ind,lin);
     Inc(Ind);
     if Ind<=ItemCount(lin) then
      begin
       val(ItemStr(Ind,lin),tim,j);
       if tim>0 then timo:=tim;
      end;
     One_tone;
    end
   else
    begin
     val(lin,sl,j);
     if j>0 then
      begin
       tton:=lin;
       One_Tone
      end
     else
      sound_length:=sl;
    end;
  end;
until eof(mel);
nosound;
close(mel)
end.
