Unit PG256; {POCITACOVA GRAFIKA: 256 barev na adapteru VGA}

          {  CZECH COMMENTS, WITH ACCENTS STRIPPED OFF   }

{**************************************************************************}
{*                                                                        *}
{*  Jiri Zara a kolektiv : POCITACOVA GRAFIKA - principy a algoritmy      *}
{*                         -----------------------------------------      *}
{*                                                                        *}
{*  (C) nakladatelstvi Grada                                              *}
{*                                                                        *}
{**************************************************************************}

Interface

  type
      RGB_entry = record
                    R,G,B : byte;
                  end;
      RGB_palette = array [0..255] of RGB_entry;

  procedure PG256_Start;
  procedure PG256_End;
  procedure Set256_Palette (var nova_paleta : RGB_palette);
  procedure Get256_Palette (var nova_paleta : RGB_palette);
  procedure Set256_Pixel (x, y : integer; barva : byte);
  function  Get256_Pixel (x, y : integer): byte;

Implementation

uses dos;

  type  typ_rastr=array [0..199,0..319] of byte;
  var
        rastr : typ_rastr absolute $A000:$0000;
        reg : registers;

procedure PG256_set_mode (mode: byte);
  begin
    reg.ah := 0;
    reg.al := mode;
    intr ($10, reg);
  end;

procedure PG256_Start;
  begin
    PG256_set_mode ($13);  { rezim 320x200 v 256 barvach na VGA }
  end;

procedure PG256_End;
  begin
    PG256_set_mode (3);  { znakovy rezim 25 radek, 80 sloupcu }
  end;

procedure Set256_Palette (var nova_paleta : RGB_palette);
  begin
    with reg do
      begin
        ah := $10;
        al := $12;
        bx := 0;
        cx := 256;
        dx := ofs(nova_paleta);
        es := seg(nova_paleta);
      end;
   intr($10, reg);
  end;

procedure Get256_Palette (var nova_paleta : RGB_palette);
  begin
    with reg do
      begin
        ah := $10;
        al := $17;
        bx := 0;
        cx := 256;
        dx := ofs(nova_paleta);
        es := seg(nova_paleta);
      end;
    intr($10, reg);
  end;

procedure Set256_Pixel (x, y : integer; barva: byte);
  begin
    rastr [y, x] := barva;
  end;

function Get256_Pixel (x, y : integer): byte;
  begin
    Get256_Pixel := rastr [y, x];
  end;

end. {unit PG256}
