 {~ Output is a part of input file starting and ending at some % of its length ~}

{$N+ $E+} {to be able to use the type "double"}
program CutBE;

const cl=#13#10;

hlptxt1= cl+
'cutbe <input file> [/b#] [/e#] [output file]'+cl;
hlptxt2=
'writes the part of the <input file> starting at /b per cent (default 0)' +cl+
'and ending at /e per cent (default 100) to the output file (default *.Res)' +cl+
                                                                   cl+
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

Siz_of_buf = 4096;

const hund:double=0.01;
var InFile,OuFile:string[50];
    InF,OuF: file;
    part,j: byte;
    code: integer;
    NoRead, NoWritten, To_be_read : word;
    buf : array [1..Siz_of_buf] of char;
    size, position : longint;
    par: string;

Procedure Help;
begin
{Highvideo;}
writeln(hlptxt1);
{Lowvideo;}
writeln(hlptxt2);
halt;
end;

begin
    j:=Paramcount;
    if j<2 then Help else
      InFile:=ParamStr(1);
    assign(InF,InFile);
 FileMode:=0; {will open the files by reset as Read Only}
    reset(InF,1);
    size:=filesize(InF);
    OuFile:=copy(InFile,1,pos('.',InFile))+'res';


    par:=paramstr(2); j:=2;

    if (par[1]<>'/') and (par[1]<>'-') then help;

    if (par[2]='b') or (par[2]='B') then
     begin
       val(copy(Par,3,length(Par)-2),part,code);
       if code>0 then help else position:=trunc(hund*size * part);
       seek(InF,position);
       position:=size;
       if ParamCount>j then begin inc(j); par:=paramstr(j) end else Par:=''
     end;


    If Par<>'' then
     begin
      if (par[1]='/') or (par[1]='-') then
       if (par[2]='e') or (par[2]='E') then
        begin
         val(copy(Par,3,length(Par)-2),part,code);
         if code > 0 then help else
           position:= trunc(hund * size * part);
         if ParamCount>j then begin inc(j); par:=paramstr(j) end else Par:=''
        end
       else begin writeln(Par,' is a parameter of an unknown meaning'); help end;
      If Par<>'' then OuFile:=Par;
     end;

    assign(OuF,OuFile);
    rewrite(OuF,1);

    repeat
        if FilePos(InF)+Siz_of_buf>position then
         To_be_read:=Position-FilePos(Inf)  else
         To_be_read:=Siz_of_buf;
        BlockRead(InF,buf,To_be_read,NoRead);
        BlockWrite(OuF,buf,NoRead,NoWritten) ;
    until (NoRead=0) or (NoRead<>NoWritten) ;
    close (InF); close(OuF);
end.
