 {~ Graphs and histograms from dBase files and from really text files. ~}
 {~  (Offers finding symmetry axis, polynomial regression, ~}
 {~   PostScript and LaTeX outputs.) ~}

Program graph_d;
 {by Jan Hollan, Obs. and Planetarium Brno, version 2.1, 1999-10-02 }
 (* Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)
     {an adaptation with the default print option for the CS212-25 printer
        - P    asks for printing directly to printer,
      <number> for printing as a picture of a given number
             to the file DbFileName.prn (or .e9 or .e24)
             created eventually in the directory given by the TEMP variable
     - for Epson 9 or 24 needle printer change the starting value
       of Printer_mode }

  {present limitations:
         - identifies but does not use the field with
           the Standard deviation of Y[1]}
uses
{standard Borland Turbo Pascal units:}
 crt, graph, dos,
{J.Hollan's units:}

 graph_m8, {screen graphic in 16'ths of a pixel, optional PS or LaTeX file}
 Str_num,  {string to numbers and vice versa conversions}
 Un_Str_M, {a free substitute for: Unit_str by Blaise Computing,Inc.}
 DbBridge, {creating, writing to and reading dBaseIII+ (*.dbf) files,
                 based on a source written by Dr. Milan Drasil}
 g_scree,  {copies of the screen or its part to disk or printer,
            in screen-proper format, in Epson format
            or in an old CS 212-25 printer format}
 Regress,  {algebraic regression, simplified from source contained
            in package "Numeric Recipes" by Cambridge Univ.Press (probably)}
 angles_o,
 params_g;

const
Printer_mode:byte=1; {9 for 9-needle Epson printer, 24 for 24-needle printer}

h10=
'Histograms and graphs from dBase and (really) text files;'+cl+
'Numeric values may be stored as Character fields as well - missing values'+cl+
'can be coded by empty or non-numeric strings (also Y=99.9 means unknown).'+cl;

h20=
'Basic command is:'+cl2;

h30=
' Graph_d <name of the (dBase or text) file>'+cl2;

h35=
'Further parameters are optional; no Y-variable implies making a histogram:'+cl2+

' <X-variable>'+cl;
h40=
' # of desired Y-variables (<=5, default 1 when anything follows)'+cl+
' <Y-variable> [<2-nd Y variable> ...]' +cl2;
h45=
'Basic options (any order, maximum twenty) are controlled by keywords'+cl+
'and words/values separated by blanks:' +cl2;

h50=
' R[X]           - reversed orientation of the Y [X] axis (not for histograms)'+cl;
h60=
' S   #          - the number of the first record (Start of scope)'       +cl+
' N   #          - Number of records to be processed (length of scope)'   +cl+
' WS  <field> <string> - only While the field equals to the String'      +cl;
h70=
' WN  <field> #   - only While the field contents equals to the Number'    +cl+
' INA <field> # # - And having the field contents within the Interval'     +cl+
' INO <field> # # - Or  having the field contents within the Interval'   +cl;
h80=
' ESA <field> <string> - And having the field beginning Equal to the String'+cl+
' ESO <field> <string> - Or  having    -  "  -    to the String (^ means blank)'+cl+
' REG        - polynomial regression of the first Y variable'           +cl;
h90=
' OUT <file name> - file for the results of histogram or regression'           +cl+
' DEP <field> - field for writing the departures from the regression line'+cl+
' DEX <field> - field for writing the horizontal (!) departures from it' +cl;
h100=
' COM <field> - field for writing the computed Y value'                +cl+
' SDF <field> - field containing the Standard deviation of Y'          +cl+
' LAB <field> - field for labelling the points'                        +cl;
h110=
' DER <field> - field for writing the derivation'+cl+
' PER #      - period of the X-variable, multiples of which will be substracted'+cl+
' MIR        - an axis of symmetry to fold the data around will be sought'+cl;
h120=
' PT <output file with a complete LaTeX file version of the screen>'      +cl+
' PT -<output file with just a LaTeX picture version of the screen>'      +cl;
h130=
' PP <-     "    -   an Encapsulated PostScript  -  "  -  >' +cl+
' M {9 | 24} needle Epson printer for hardcopy;'+cl+
'  pressing P makes hardcopy to "prn", any # to a same-named file with suffix'+cl;
h140=
'  .prn (or .e9 or .e24) in the TEMP dir;'+cl+
'  (default of 1 means a CS212-25 printer)' +cl2+

'Example (input from Algol.dbf):'+cl+
' Graph_d Algol MJD 1 V_dmag R PP Algol.eps'+cl;

h150=cl+
'If the input file is a text one, fields (=columns) are words separated'+cl+
'usually by blanks, counting from the beginning of each line.'+cl;
h160=
'Lines with non-numeric contents  in x or y columns are ignored.'+cl2+

'<field> is either a name of the dBase field,'+cl+
'or its number in a record (on a line, for text files) preceded by / or -.'+cl+
'/0 (a fictive field zero) is number of record (or line).'+cl;
h170=
'The parameters starting with / (-) are:'+cl2;

h180=
' /x#  Number of x-column (default 1; /x0 means record (line) No.)'+cl+
'(/x#:# Starting position and length of x-field, just for text files)'+cl+
' /y#  Number of y-column (default 2)'+cl;
h181=
'(/d#  decadic code of delimiter -- default 32, i.e. blank --'+cl+
'     or delimiting character itself. Just for text files.)'+cl+
' /his      Make a histogram'+cl2;
h190=
' /xd<word> Description of x-axis (default "column #" or name of x-field)'+cl+
' /yd[#]<word> Description of y-axis (default "column #" or name of [first] y-field)'+cl+
' /t<word of title> of the picture (additive, command line used when no /t)'+cl;
h191=
' /b[-] Draw (default) or do not draw (/b-) picture border'+cl;
h200=
' /xs# side along X coordinate / 1 % of the screen (default 100)'+cl+
' /ys# side along Y coordinate / 1 % of the screen (default 100)'+cl;
h201=
' /z# Forced zero for x-axis (constant that is subtracted from X)'+cl+
' /zy#   -    "   -   y-axis (constant that is subtracted from all Ys) '+cl;
h210=
' /l 1000*log(count) on y-axis for histogram (just 0 as 0 and 1 as 100)'+cl;
h211=
' /m[t] just marks on axes (default), lines through the whole graph when /mt'+cl+
' /m:[c]#:#:{[c]#|p<formula>}:# forced margins <min x>:<max x>:<min y>:<max y>'+cl+
'   (instead of <min>:<max>, C<center>:<width> can be given,'+cl;
h212=
'    instead of the C<central y>,'+cl+
'    P<quadratic formula for its computation> can be given as  x0!c!p!q'+cl+
'    meaning <central y> = c + (<central x>-x0)*p + sqr(<central x>-x0)*q )'+cl;
h213=
' /n<file> name of further file to be included into plot'+cl+
'    (regression concerns just the first file)'+cl;
h220=
' /f#:#[:#] for histogram: forced center (instead of average),'+cl+
'    width of column, and perhaps number of columns on each side'+cl+
'    (default and maximum is 30); recommendation: first run with no /f.'+cl2;
h222=
' Each Y-field specification can continue by :<additive const>[:<coef.>]'+cl+
'    for linear transformation of that field (default :0:1),'+cl+
'    the same holds for futrther file names (max. 8 ones)'+cl2;
h230=
'Example:'+cl+
' Graph_d RT_And.dat R PT RT_And_g.ltx /x2 /y4 /xdMJD /ydV/1dmag'+cl2;
h230b=
' ?, no or wrong parameters:    display this information,' +cl+
' /h  write this information to a file Graph_d.hlp'+cl2;
h240=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

NofCon=24;

Type
  Condition =
   (R,RX,S,N,WN,WS,ESO,INO,ESA,INA,REG,OUT,DEP,DEX,COM,SDF,LAB,DER,PER,MIR,UNK,PP,PT,M,SW);
Var
  Cond : array [1..20] of Condition;
  Symb : Condition;

Const
  Message:string='';
  FindDeli:boolean=true;
  MaxYfields=7;
  MaxFFiles=8;
  MaxTrans=MaxYFields+MaxFFiles;
  SwitchArray : array[1..NofCon] of string[3] =
('R','RX','S','N','WN','WS','ESO','INO','ESA','INA','REG','OUT','DEP','DEX','COM',
                       'SDF','LAB','DER','PER','MIR','PP','PT','M','SW');
  CondArray : array[1..NofCon] of Condition =
   (R,RX,S,N,WN,WS,ESO,INO,ESA,INA,REG,OUT,DEP,DEX,COM,SDF,LAB,DER,PER,MIR,PP,PT,M,SW);
  NCond : byte = 0;
  FN : array [1..9] of byte = (1,1,1,1,1,1,1,1,1);
  WhileNum : real = 0;
  WhileStr : string[10] = '';
  OrStr : string [10] = '';
  AndStr : string [10] = '';
  OrNumLo : Real = 0;
  OrNumHi : Real = 0;
  AndNumLo : Real = 0;
  AndNumHi : Real = 0;
  OutFileWanted : boolean = False;
  Departures : boolean = false;
  DeparturesX : boolean = false;
  Comp_Y     : boolean = false;
  Regression : boolean = false;
  LabelWanted: boolean = false;
  LabelOnly:   boolean = false;
  Derivation : boolean = false;
  Periodic   : boolean = false;
  Margins_Set: boolean = false;
  SNR : word = 0;            {Number of selected records}
   xUnknown : real = 99.9 ;
   yUnknown : real = 99.9 ;
   Fy : array [1..MaxYfields] of byte = (2,0,0,0,0,0,0);
   Margin : byte = 0;
   Fx  : byte = 1;
   Ny  : byte = 0;   {number of Y-fields, maximally MaxYfields}
   {Ff  : byte = 1;}
   SDField : byte = 0;
   DepField : byte = 0;
   DepXField : byte = 0;
   Comp_Y_Field: byte = 0;
   LabField : byte = 0;
   Deriv_Field: byte = 0;
   NPar: byte = 0;
   PPar: byte = 0;
   {FiltVal: real = 0;
    FiltValUp: real = 0;
    FiltStr: string[15] = '';
    FiltPres: boolean = False;
   }
   StN : word = 0;
   Number: word = 65535;
   resp   : string='';
   ParamLine:string ='';
   Mirror:boolean=false;  {are data to be folded around a symmetry axis?}
   FirstTime:boolean=true; {first passage through folding setttings}
   dBase:boolean=true;  {input from a dBaseIII+ file}
   x_descr:string='column 1';
   x_descr_set: boolean = false;
   y_descr: array [1..maxYfields] of string[60]=('column 2','','','','','','');
   y_descr_set: array [1..maxYfields] of boolean =
    (false,false,false,false,false,false,false);
   title:string='nothing';
   {jp:byte=2; order of positional codegree_plus_1nd-line parameter}
   Zero_X:real=0;
   Origin_X:real=0;
   Origin_Y:real=0;
   Origin_Str:string='';
   Origin_Y_Str:string='';
   LeftBr:string[1]='';
   LeftBr_Y:string[1]='';
   Origin_forced:boolean=false;
   Origin_Y_forced:boolean=false;
   XS:byte=100;
   YS:byte=100;
   NoForcedColons:boolean=true;
   logarithmic:boolean=false;
   JustHistogram:boolean=false;
   NumberOfFiles:byte=1;
   NoRX:boolean=false;
   WriteForAll:boolean=true;
   x_max_per:real=0; {maximal positive fraction of a period}
   x_min_per:real=0; {maximal negative fraction of a period}
   YCoef:array [1..MaxTrans] of real = (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
   YCoefStr:array [1..MaxYFields] of string[12] = ('','','','','','','');
   YAddiStr:array [1..MaxYFields] of string[12] = ('','','','','','','');
   YAddi:array [1..MaxTrans] of real = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   YTrans:array [1..MaxTrans] of boolean =
    (false,false,false,false,false,false,false,
     false,false,false,false,false,false,false,false);
   Deli:char=' ';
   point_r :byte=1;
   weight_shift:boolean=true;
   const FileNo:byte=1;
   BatchMode:boolean=false;
                     {true would not wait for pressing a key at the end}
Var
   inp_text_f,OutFile: text;
   DbFileName: PathStr;
   FileName: array[1..MaxFFiles] of PathStr;
  {FiltSymb,}
   ch : char ;
  {param  : array [1..8] of string [15];}
   FieldX :string[10];
   Param_o, Param_U, par : string[60];
   PolDegree, LenOrStr, LenAndStr : byte;
   Sig    : shortint;
   j,k,i  : integer;
   Count  : array [-30..30] of word;
   Num, {DescStep,} Ycoord,sx :  word ;
   NoR    : longint;
   X, Period, Width, Av, SD, Lmar, Rmar, incr, To_units, Center,
    HalfPeriod, BaseX, aux_r, yy,yd: real;
   Y:   array [1..MaxYfields] of real;
   YP:  array [1..MaxYfields] of boolean;
   NEnOfFi, XP : Boolean;
   TextLine,aux_s:string; IC:byte;
   GM_Mode_true,StartFx,LenFx:byte;
   Ylstr:string[1];
   Yrstr:string[30];


Procedure quit;
begin
 gm_close;
 if dBase then DbClose;
 if OutFileWanted then close(OutFile);
 if Message<>'' then writeln(Message);
 halt
end;

Procedure help;
begin
 LowVideo; write(cl,h10,h20);
 HighVideo; write(h30);
 LowVideo; write(h35);
 write(h40,h45,h50,h60,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h70,h80,h90,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h100,h110,h120,h130,h140,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h150,h160,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h170,h180,h181,h190,h191,h200,h201,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h210,h211,h212,h213,h220,h222,h230,h0last);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt;
 write(h0clear,h_svga1,h_svga2,cl,h230b,h240);
 quit;
end;

procedure help_file;
var h_file:text;
begin
 if rt_rewrite(h_file,'Graph_d.hlp') then
  begin
   write(h_file,
    h10,h20,h30,h35,
    h40,h45,h50,h60,h70,h80,h90,
    h100,h110,h120,h130,h140,
    h150,h160,h170,h180,h181,h190,h191,h200,h201,
    h210,h211,h212,h213,h220,h222,h230,h_svga1,h_svga2,cl,h230b,h240);
   close(h_file);
   halt;
  end
 else help;
end;

procedure Periodize;
begin
 X:=frac((X-BaseX)/Period)*Period;
end;

Procedure PrintScrWanted;
var NumPic : byte;
 fDir:DirStr; fNam:NameStr; fExt:ExtStr;
begin
 if (resp[1]='p') or (resp[1]='P') then PriGScr('',0,Printer_mode)
 else
  begin
   val(copy(resp,1,length(resp)),NumPic,j);
   if J=0 then
    begin
     Fsplit(DbFileName,fDir,fNam,fExt);
     PriGScr(fDir+fNam,NumPic,Printer_mode);
    end
  end
end;


procedure ParamUp (j:byte);
begin
 Param_o:=ParamStr(j);
 Param_U:=__cvtstr(ParamStr(j),_to_upcase_str);
end;

Function IdentFieldNum(aux_s:string):byte;
                       {gives the number of the field aux; halts when fails}
var k: byte;
begin
  if aux_s[1] in ['/','-'] then
   k:=par2i(aux_s)
  else
   begin
    k:= DbFieldNum(aux_s);
    if k=0 then
     begin
      writeln('there is no such field >',aux_s,'< in the file ',DbFileName);
      quit
     end;
   end;
  IdentFieldNum:=k
end;

Procedure IdentCondField;
begin
  inc(NCond);
  FN[NCond]:=IdentFieldNum(Param_U);
  inc(PPar);
  ParamUp(PPar);
  Cond[NCond]:= Symb
end;


Procedure Interval  (var NumLo: Real; var NumHi: Real);
var NumAux: real;
begin
IdentCondField;
  val(Param_U,NumLo,j);
  if j > 0 then
     begin
      writeln('The lower limit of the interval : (',Param_U,
              ') is no number');
      quit;
     end
   else
     begin
      inc(PPar);
      ParamUp(PPar);
      val(Param_U,NumHi,j);
      if j > 0 then
       begin
        writeln('The upper limit of the interval (',Param_U,
              ') is no number');
        quit;
       end
     end;
  If NumHi<=NumLo then  {reversing the limits}
   begin
     NumAux:=NumHi;
     NumHi:=NumLo;
     NumLo:=NumAux
   end;

end;


Function Range : boolean;

var R : boolean;  RN : real; S:string;

begin
 R:= NEnOfFi;
 if R then
  for j:= 1 to NCond do
   begin
    if (FN[j]>0) and (Cond[j] in [WN,WS]) then
     begin
      if dBase then S:= rec[FN[j]]
      else
       if FN[j]<=IC then S:=ItemStrD(Deli,FN[j],TextLine)
       else
        begin
         Range:=false;
         exit
        end;
     end
    else S:='';
    case Cond[j] of
     N  : R:= R and (NoR<= StN+Number);
     WN : begin
          val(__cvtstr(S,_rem_white_str),RN,k);
          R:= R and (RN = WhileNum)
         end;
     WS : R:= R and (S = WhileStr);
    end;
   end;
 Range:= R;
end;

Function Filter : boolean;
var N : real;
    F: boolean ;
    S, LS: string;
begin
  F:= True;
  for j:= 1 to NCond do
   begin
    if FN[j]>0 then
     begin
      if dBase then S:= rec[FN[j]]
      else
       if FN[j]<=IC then S:=ItemStrD(Deli,FN[j],TextLine)
       else
        if Cond[j] in [ESA,INA] then
         begin Filter:=false; exit end;
     end
    else
     S:='';
    case Cond[j] of
     ESA : F:= F and (copy(S,1,LenAndStr) = AndStr);
     ESO : F:= F or (copy(S,1,LenOrStr) = OrStr);
     INO, INA : begin
                 if FN[j]>0 then
                  begin
                   LS:= __cvtstr(S,_rem_white_str);
                   val(LS,N,k);
                  end
                 else
                  N:=NoR;
                 if Cond[j]=INA then
                  F:= F and ((AndNumLo <= N) and (N <= AndNumHi))
                 else
                  F:= F or ((OrNumLo <= N) and (N <= OrNumHi));
                end;
     end;
   end;
  Filter:= F
end;



Function StartRecHis(var NoR:longint; Fx:byte; var X:real): boolean ;

{Reads starting record from a dBaseIII+ file and puts field Fx into X}
var {TextLine:string; IC:byte;} j:integer;

begin
 if dBase then
  begin
   StartRecHis:= DbRead(NoR,rec);
   val(__cvtstr(rec[Fx],_rem_white_str),X,J);
   XP:= (j=0);
  end
 else
  begin
   j:=1;
   while (j>0) and not(eof(inp_text_f)) do
    begin
     readln(inp_text_f,TextLine);
      if keypressed then begin writeln(TextLine); halt; end;
     if FindDeli then
      begin
       IC:=ItemCountD(Deli,TextLine);
       if Fx <= IC then val(ItemStrD(Deli,Fx,TextLine),x,j);
      end
     else
      val(copy(TextLine,StartFx,LenFx),x,j);
    end;
   XP:=(j=0);
   StartRecHis:= XP;
  end;
 if Origin_forced then X:=X-Origin_x;
end;

Function NexRecHis(var NoR:longint; Fx:byte; var X:real): boolean ;

{Reads next record from a dBaseIII+ file and puts field Fx into X}

{It is written separately and not with help of DbRead to avoid codegree_plus_1nd
SEEK - as the position within the file is OK already - but this is quite
unnecessary probably as the codegree_plus_1nd SEEK should be quick enough. Otherwise
it would match StartRecHis completely.}

var i,j:integer;{var TextLine:string; IC:byte;}

begin
 if dBase then
  begin
   if NoR>DbNurec
    then
     NexRecHis:=FALSE
    else
     begin
      NexRecHis:=TRUE;
      BlockRead (fd,OneRec,DbRecl);
      k:=2;
      for i:=1 to DbNuField do
       begin
        for j:=1 to DbInfo[i].len do
         begin
          rec[i][j]:=OneRec[k];
          inc(k);
         end;
        rec[i][0]:=chr(DbInfo[i].len);
       end;
      val(__cvtstr(rec[Fx],_rem_white_str),X,J);
      XP:= (j=0);
     end;
  end
 else
  begin
   j:=1;
   while (j>0) and not(eof(inp_text_f)) do
    begin
     readln(inp_text_f,TextLine);
      if keypressed then begin writeln(TextLine); halt; end;
     if FindDeli then
      begin
       IC:=ItemCountD(Deli,TextLine);
       if Fx <= IC then val(ItemStrD(Deli,Fx,TextLine),x,j);
      end
     else
       val(copy(TextLine,StartFx,LenFx),x,j);
    end;
   NexRecHis:= (j=0);
   XP:=(j=0);
  end;
 if Origin_forced then X:=X-Origin_x;
end;


Function NexRecPlot {var NoR:longint; Fx:byte; Fy: array [1..MaxYfields] of byte;
                     var X:real; var Y: array [1..MaxYfields] of real}: boolean ;

{Reads next record from a dBaseIII+ file and fills X and Y}
var j:integer;
procedure Ytr;
var ia:byte;
begin
 if Origin_Y_forced then Y[i]:=Y[i]-Origin_Y;
 if YTrans[i] then Y[i]:=(Y[i]+YAddi[i])*YCoef[i];
 if FileNo>1 then
  begin
   ia:=MaxYFields+(FileNo-1);
   if YTrans[ia] then Y[i]:=(Y[i]+YAddi[ia])*YCoef[ia];
  end;
end;

begin
 if dBase then
  begin
   if DbRead(NoR,rec) then
    begin
     NexRecPlot:=true;
     if NoRX then
      begin
       X:=NoR;
       XP:=true;
      end
     else
      begin
       val(__cvtstr(rec[Fx],_rem_white_str),X,J);
       XP:=(j=0);
      end;
     if XP then
      for i:= 1 to Ny do
       begin
        if Fy[i]>0 then
         begin
          val(__cvtstr(rec[Fy[i]],_rem_white_str),Y[i],J);
          YTr;
          YP[i]:=(j=0);
          if DbInfo[Fy[i]].typ='N' then
           YP[i]:=YP[i] and (Y[i]<>YUnknown);
         end
        else
         begin
          Y[i]:=NoR;
          YTr;
          YP[i]:=true;
         end;
       end;
    end
   else NexRecPlot:=false;
  end
 else
  begin
   XP:=false;
   while (not XP) and not(eof(inp_text_f)) do
    begin
     readln(inp_text_f,TextLine);
      if keypressed then begin writeln(TextLine); halt; end;
     IC:=ItemCountD(Deli,TextLine);
     if NoRX then
      begin
       X:=NoR;
       XP:=true;
      end
     else
      if FindDeli then
       if Fx > IC then XP:=False
       else
        begin
         val(ItemStrD(Deli,Fx,TextLine),x,j);
         XP:=(j=0);
        end
      else
       begin
        val(copy(TextLine,StartFx,LenFx),x,j);
        XP:=(j=0);
       end;
     if XP then
      begin
       If NoRX then XP:=False;
       if IC>50 then
        for i:=1 to 50 do rec[i]:=ItemStrD(Deli,i,TextLine)
       else
        for i:=1 to IC do rec[i]:=ItemStrD(Deli,i,TextLine);
       for i:= 1 to Ny do
        begin
         if Fy[i] > IC then YP[i]:=false
         else
          begin
           if Fy[i]>0 then
            begin
             val(rec[Fy[i]],Y[i],j);
             YTr;
             YP[i]:=(j=0);
            end
           else
            begin
             Y[i]:=NoR;
             Ytr;
             YP[i]:=true;
            end;
           if NoRX then XP:=XP or YP[i];
          end;
        end;
      end;
    end;
   NexRecPlot:= XP;
  end;
 if Origin_forced then X:=X-Origin_x;
end;

PROCEDURE GraRead(L_U_Corner, answ_wanted: boolean; Ri:char);
var R,OldR:char; WidthOldR: word;
BEGIN
 if L_U_Corner then  {an old response is wiped away}
  begin
   moveto (5,5);
   setcolor(0) ;
   outtext(resp);
   setcolor(MaxColor);
   moveto (5,5)
  end;
 resp:= '' ;
  repeat
   if Ri=#0 then R:=readkey else R:=Ri;
   if not ((R=#13) OR (R='Q') or (R='q') or (R=#27)) then
    if R=#8  then                {BackSpace}
     begin
       WidthOldR:=TextWidth(OldR);
       moverel(-WidthOldR,0);
        setcolor(0);
        outtext(OldR);
       resp:=copy(resp,1,length(resp)-1) ;
       moverel(-WidthOldR,0) ;
        setcolor(MaxColor);
     end
    else
     begin
       outtext(R); resp:= resp+R; OldR:=R
     end
   else
    if (R='Q') or (R='q') or (R=#27) then quit;
   Ri:=#0;
  until R=#13;
  if answ_wanted and (resp='') then quit
END ; (*end of reading a line from a graphic screen*)


Procedure PlotHistogram {Num: word; Av: real; SD: real
                        Margin: integer; Width: real;
                        Count: array [-30..30] of word};

var j, {k,} WoCol, sxc:integer; norm,sqrsd2:real; descX: string[10]; LastRightX: word;
begin
  Y_min:= 0; Y_max:= 0;
  for j:=-Margin to Margin do
  if Count[j]> Y_max then Y_max:= Count[j];
  Y_max:= Y_max * 1.3 ;
  Y_max_min:=Y_max;
   {The X-margins influence here just the order of 10
    by which the X-variable will be divided: }
  X_Max:= Margin*Width+Center;
  X_Min:=-Margin*Width+Center;
  X_Max_Min:=(X_Max-X_min)/10; {/10 enables whole numbers on X-axis}
if Y_max > 0 then
 begin
  GM_init(XS,YS);
  WoCol:= Trunc((gr_right-gr_left)/(2*Margin + 2));

  gm_comm('Frame of the histogram and description:');
  if logarithmic then
   gr_frame(title+'(but 0->0,1->100)','-'+x_descr,'1000*log(count)')
  else
   gr_frame(title,'-'+x_descr,'count');
  if NoForcedColons then
   gm_outxy(gr_left,MaxY-RoundUp(0.8*TextH),
     'Average='+SRx(4,Av)+'  '+
     'Stand.Deviation='+SRx(1,SD)+'  '+
     'Width of Col.='+SRxs(0,Width),'l',0)
  else
   gm_outxy(gr_left,MaxY-RoundUp(0.8*TextH),
     'Forced Center ='+SRx(4,Av)+'  '+
     'Width of Column ='+SRxs(0,Width),'l',0);
  SetFillStyle(CloseDotFill,White{=15});
  LastRightX:=0;

  gm_comm('horiz. axis and columns:');
  for j:= -Margin to Margin do
   begin
    sx:= trunc(gr_left+(j+Margin+0.5)*WoCol);
    if j=Margin then sx:=sx+trunc(WoCol/2);
    if j=-Margin then sx:=sx-trunc(WoCol/2);
    sxc:=sx+trunc(WoCol/2);
    if abs(j)<>Margin then
     begin
      if sx>LastRightX then
       begin
        descX:=__cvtstr(SRe(10,0,(Width*j+Center)/DekExpX),_rem_white_str);
        if LastRightX < sx then
         begin
          LastRightX:=sx+24*TextWidth(descX);
          gm_outxy(sxc,gr_bottom+(TextH div 2),descX,'c',0);
          gm_line(sxc,gr_bottom-mark_l,
                  sxc,gr_bottom)
         end
       end
     end
    else
     if j=-Margin then
       gm_outxy(sxc,gr_bottom+TextH div 2,'<','c',0)
     else
       gm_outxy(sxc,gr_bottom+TextH div 2,'>','c',0);
    if count[j]>0 then
     begin
      gm_Rectangle(sx,gr_y(count[j]),sx+WoCol,gr_bottom);
      if gr_y(count[j])<gr_bottom - 64 then
       FloodFill (sxc div 16 +1, (gr_bottom + gr_y(count[j])) div 32,MaxColor);
     end
   end; {of for}
  if NoForcedColons then
   begin
    norm:=Num*width/(SD*sqrt(2*pi));
    sqrsd2:=2*sqr(SD);
    aux_r:=Center-Av;

    gm_comm('density of the normal distribution:');
    for j:= -10*Margin to 10*Margin do
     begin
      sx:=trunc(gr_left+(j/10+Margin+1)*WoCol);
      gm_circle_full(sx,gr_y(norm * exp(-sqr(j*width/10+aux_r)/sqrsd2)),10);
     end; {of for Z-density}
   end
 end
else
 begin
  Writeln('Nothing to plot - no records');
  quit;
 end
end;

procedure progress_report;
begin
 if NoR mod 200 =0 then writeln ('reading record ',NoR);
 if keypressed then halt;
end;

procedure OpenFile;
begin
 if (pos('.DBF',DbFileName)>0)
 or (pos('.',DbFileName)=0) then
  begin
   if not DbInit(DbFileName) then
    begin
     Message:='The dBase file '+DbFileName+' is not present, try again';
     quit
    end;
  end
 else
  if not rt_reset('',inp_text_f,DbFileName) then
   begin
    Message:='The input text file '+DbFileName+' is not present, try again';
    quit
   end
  else
   dBase:=false;
end;

procedure StartOfFile;
begin
 if StN>1 then
  begin
   NoR:=StN;
   if not dBase then
   begin
    for NoR:=1 to StN-1 do if not eof(inp_text_f) then readln(inp_text_f);
    {NoR:=1; what was that for? I've commented the line out.}
   end;
  end
 else NoR:=1;
end;

{all the following procedures are just parts of the main programme body:}

procedure Parameters;
var
 Further,No_FieldX:boolean;Pos_Y:byte;
const
 Posi_Par:byte=1;Posi_Par_before_cond:byte=1; YNew:byte=0;

  procedure check_transf(jj_y:byte;tran_str:string);
   var bt:boolean; aux_sc:string;
   begin
    if ItemCountD(':',tran_str)>1 then
     begin
      bt:=jj_y<=MaxYFields;
      YTrans[jj_y]:=true;
      aux_sc:=ItemStrD(':',2,tran_str);
      YAddi[jj_y]:=R_S(aux_sc);
      if bt then
       if (YAddi[jj_y]=0) then
        YAddiStr[jj_y]:=''
       else
        if YAddi[jj_y]>0 then
         YAddiStr[jj_y]:=' + '+aux_sc
        else
         YAddiStr[jj_y]:=' - '+copy(aux_sc,
               2,length(aux_sc)-1);
      if ItemCountD(':',tran_str)>2 then
       begin
        aux_sc:=ItemStrD(':',3,tran_str);
        YCoef[jj_y]:=R_S(aux_sc);
        if bt then YCoefStr[jj_y]:=' * '+aux_sc;
       end;
     end;
   end;

 procedure Conditions;
  var j_Y:byte; lenpar:byte;

  begin {of Conditions}
   while PPar<Npar do
    begin
     inc(PPar);
     ParamUp(PPar);
     par:=param_o;
     Symb:=UNK;
     for k:= 1 to NofCon do if Param_U=SwitchArray[k] then Symb:=CondArray[k];
     if Par[1] in ['/','-'] then
      begin
       Symb:=SW;
       Further:=true;
      end
     else
      begin
       inc(Posi_Par);
       if Posi_Par>Posi_Par_before_cond then
        Further:=true
       else
        Further:=false
      end;
     if Further then
      begin
       inc(PPar);
       if (PPar<= NPar) and (symb<>SW) then ParamUp(PPar);
       case Symb of
{Reverse_Y}       R : begin
          Reverse_Y:=True;  {vertical axis should be reversed}
          dec(PPar)
        end;
{Reverse_X}       RX: begin
          Reverse_X:=True;  {horizontal axis should be reversed}
          dec(PPar)
        end;
{Start , NoR}     S : val(Param_U,StN,j);   {Starting with record number StN}
{Next  , Number}  N : begin             {processing just Number of next rec.}
           val(Param_U,Number,j);
           if j = 0 then
             begin
               inc(NCond);
               Cond[NCond]:= N
             end
        end;
{WhileNumber,F,N} WN: begin             {while a field equals to a number}
            IdentCondField ;
            val(Param_U,WhileNum,j);
            if j > 0 then dec(NCond);
          end;
{WhileString,F,S} WS: begin             {while a field equals to a string}
            IdentCondField ;
            WhileStr:= Param_o;
          end;
{EqualToStringAnd,F,S}
    ESA:begin
            IdentCondField ;
            AndStr:= Param_o;
            LenAndStr:=length(AndStr);
            for j:=1 to LenAndStr do
             if AndStr[j]='^' then AndStr[i]:=' ';
          end;

{IntervalNumberAnd}INA: Interval(AndNumLo,AndNumHi) ;

{EqualToStringOr,F,S}
    ESO: begin
            IdentCondField;
            OrStr:= Param_U;
            LenOrStr:=length(OrStr);
            for j:=1 to LenOrStr do
             if OrStr[j]='^' then OrStr[i]:=' ';
          end;
{IntervalNumberOr} INO: Interval(OrNumLo,OrNumHi) ;

{file for writing the results}
    OUT: begin
          OutFileWanted:=True;
          assign(OutFile,Param_o{U});
          rewrite(OutFile)
         end;

{regression wanted}REG: begin
          Regression:=true;
          dec(PPar)
         end;

{Departures field name}
    DEP: begin Departures:=true;
               DepField:=IdentFieldNum(Param_U)
         end;
{Departures in X field name}
    DEX: begin DeparturesX:=true;
               DepXField:=IdentFieldNum(Param_U)
         end;
{Computed Y field name}
    COM: begin Comp_Y:=true;
               Comp_Y_Field:=IdentFieldNum(Param_U)
         end;

{Standard deviation field name}
    SDF : SDField:= IdentFieldNum(Param_U);

{Label field name}
    LAB: begin if Param_U[1]=':' then
                begin
                 LabelOnly:=true;
                 Param_U:=copy(Param_U,2,length(Param_U)-1);
                end
               else LabelWanted:=true;
               LabField:=IdentFieldNum(Param_U)
         end;
{Derivation field name}
    DER: begin Derivation:=true;
               Deriv_field:=IdentFieldNum(Param_U)
         end;

{Period of an X-variable}
    PER: begin
          Periodic:=true;
          val(Param_U,Period,j);
          HalfPeriod:=Period/2;
          if j > 0 then Periodic:=false;
         end;
    MIR: begin Mirror:=true; regression:=true; dec(PPar) end;
  PP,PT: begin
          GM_OuFile:=Param_o{U};
          if Symb=PP then GM_Mode:=3
          else
           if GM_OuFile[1]='-' then
            begin
             GM_Mode:=22;
             GM_OuFile:=copy(GM_OuFile,2,length(GM_OuFile)-1);
            end
           else
            GM_mode:=2;
         end;
      M: Printer_mode:=I_S(Param_U);
     SW: begin
          dec(PPar);
          lenpar:=length(par);
          if lenpar>1 then
          case Param_U[2] of
           'B': if lenpar>2 then
                 if Par[3]='-'then
                  Draw_Picture_Border:=' '
                 else
                  Draw_Picture_Border:='R';
           'D': if lenpar>2 then
                 if ord(par[3])<64 then
                   Deli:=chr(ss2i(par,3))
                 else
                   Deli:=par[3];
           'F': begin
                 par:=copy(par,3,lenpar-2);
                 if ItemCountD(':',par)>1 then
                  begin
                   Av:=R_S(ItemStrD(':',1,par));
                   Width:=R_S(ItemStrD(':',2,par));
                   if ItemCountD(':',par)=3 then
                    Margin:=I_S(ItemStrD(':',3,par))
                   else Margin:=30;
                   if (Width>0) and (Margin>0) then
                    NoForcedColons:=false;
                  end;
                end;
           'H': if Param_U[3]='I' then JustHistogram:=true
                else help_file;
           'L': logarithmic:=true;
           'M': if lenpar>2 then
                 if Param_U[3]='T' then
                  gr_through:=true
                 else
                  begin  {setting margins}
                   if ItemCountD(':',Par)=5 then
                    begin
                     aux_s:=ItemStrD(':',2,Param_U);
                     if aux_s[1]='C' then
                      begin
                       X_min:=R_S(copy(aux_s,2,length(aux_s)-1));
                       X_max:=R_S(ItemStrD(':',3,par));
                       aux_r:=X_max/2;
                       X_max:=X_min+aux_r;
                       X_min:=X_min-aux_r;
                      end
                     else
                      begin
                       X_min:=R_S(aux_s);
                       X_max:=R_S(ItemStrD(':',3,par));
                      end;
                     aux_s:=ItemStrD(':',4,Param_U);
                     case aux_s[1] of
                      'C':
                       begin
                        Y_min:=R_S(copy(aux_s,2,length(aux_s)-1));
                        Y_max:=R_S(ItemStrD(':',5,par));
                        aux_r:=Y_max/2;
                        Y_max:=Y_min+aux_r;
                        Y_min:=Y_min-aux_r;
                       end;
                      'P':
                       begin
                        aux_s:=copy(aux_s,2,length(aux_s)-1);
                        if ItemCountD('!',aux_s)<>4 then halt;
                        Y_min:=(X_max+X_min)/2 - R_S(ItemStrD('!',1,aux_s));
                        Y_min:=R_S(ItemStrD('!',2,aux_s))+
                           Y_min*
                            (R_S(ItemStrD('!',3,aux_s))
                             +Y_min*R_S(ItemStrD('!',4,aux_s)));
                        Y_max:=R_S(ItemStrD(':',5,par));
                        aux_r:=Y_max/2;
                        Y_max:=Y_min+aux_r;
                        Y_min:=Y_min-aux_r;
                       end
                      else
                       begin
                        Y_min:=R_S(aux_s);
                        Y_max:=R_S(ItemStrD(':',5,par));
                       end;
                     end;
                     X_max_min:=X_max-X_min;
                     Y_max_min:=Y_max-Y_min;
                     BaseX:=X_min;
                     if (X_max_min>0) and (Y_max_min>0)
                      then Margins_Set:=true
                    end
                   else
                    if pos(':',Par)>0 then
                     begin
                      writeln(
'The parameter giving margins has to begin by "m:" and have all four components.');
                      halt;
                     end
                  end
                else
                 gr_through:=false;
           'N': if NumberOfFiles<=MaxFFiles then
                 begin
                 par:=copy(Param_o{U},3,lenpar-2);
                 inc(NumberOfFiles);
                 FileName[NumberOfFiles]:=ItemStrD(':',1,par);
                 check_transf(MaxYFields+NumberOfFiles-1,par);
                 end;
           'S': Par_SVGA;
           'T': begin
                 if title='nothing' then title:='';
                 title:=title+' '+copy(par,3,lenpar-2);
                end;
           'X': if lenpar>2 then
                 case Param_U[3] of
                 'D': if lenpar>3 then
                       begin
                        x_descr:=copy(par,4,lenpar-3);
                        x_descr_set:=true;
                       end;
                 'S': XS:=RoundUp(par_num(copy (Par,3,lenpar-2)))
                 else
                  begin
                   if pos(':',par)>0 then
                    begin
                     FindDeli:=false;
                     StartFx:=I_S(ItemStrD(':',1,
                      copy(par,3,lenpar-2)));
                     LenFx:=I_S(ItemStrD(':',2,par));
                     if not (StartFX>0) and(LenFx>0) then
                      halt;
                    end
                   else
                    begin
                     Fx:=ss2i(par,3);
                     if dBase and (Fx>DbNuField) then quit;
                     if Fx=0 then
                      NoRX:=true
                     else if not dBase then
                      x_descr:='column'+SI(2,Fx);
                    end
                  end;
                 end;
           'Y': if lenpar>2 then
                case Param_U[3] of
                'D': if lenpar>3 then
                      begin
                       j_Y:=I_S(Par[4]);
                       if j_Y in [1..MaxYFields] then
                        begin
                         if lenpar>4 then
                          y_descr[j_y]:=copy(par,5,lenpar-4);
                         y_descr_set[j_y]:=true;
                        end
                       else
                        begin
                         y_descr[1]:=copy(par,4,lenpar-3);
                         y_descr_set[1]:=true;
                        end;
                      end;
                'S': YS:=RoundUp(par_num(copy (Par,3,lenpar-2)));
                else
                 begin
                  aux_s:=copy(par,3,lenpar-2);
                  Pos_Y:=I_S(ItemStrD(':',1,aux_s));
                  if Ny<MaxYfields then
                   begin
                    inc(Ny);
                    Fy[Ny]:=Pos_Y;
                    if (not dBase) and (Pos_Y>0) then
                     y_descr[Ny]:='column'+SI(2,Pos_Y);
                    check_transf(Ny,aux_s);
                    if dBase and (Pos_Y>DbNuField) then quit;
                   end
                  else
                   writeln('Too many Y-fields, maximum is',
                            MaxYfields:2,'!');
                 end;
                end;
           'Z': if Param_U[3]='Y' then
                 begin
                  Par:=copy(par,2,lenpar-1);
                  Origin_Y:=R_S(copy(par,3,lenpar-2));
                  if Origin_Y<>0 then
                   begin
                    Origin_Y_forced:=true;
                    Origin_Y_Str:=' - '+copy(par,3,lenpar-2)+')';
                    LeftBr_Y:='(';
                   end;
                 end
                else
                 begin
                  Origin_X:=R_S(copy(par,3,lenpar-2));
                  if Origin_X<>0 then
                   begin
                    Origin_forced:=true;
                    Origin_Str:=' - '+copy(par,3,lenpar-2)+')';
                    LeftBr:='(';
                   end;
                 end;
          end
         end;
        else begin
              ParamUp(PPar-1);
              writeln('This is no symbol of condition: >',
                       Param_o,'< !');
              quit
             end;

       end; {of case}
      end; {of Further}
    end; {of While}

  end;  {of conditions}

 function New_Positional_Parameter:boolean;
 begin
  inc(PPar);
  par:=ParamStr(PPar);
  while (Par[1] in ['-','/']) and (PPar<=NPar) do inc(PPar);
  if PPar<=NPar then
    begin
     ParamUp(PPar);
     inc(Posi_par);
     New_Positional_parameter:=true;
    end
  else  New_Positional_parameter:=false;
 end;

begin
 inc(PPar);
 for j:=1 to ParamCount do ParamLine:=ParamLine+ParamStr(j)+' ';
 if pos('?',ParamLine)>0 then Help;
 ParamUp(PPar);
 if (Param_U='/H')
 or (Param_U='-H') then Help_File;
 if (pos(' /H ',__cvtstr(ParamLine,_to_upcase_str))>0)
 or (pos(' -H ',__cvtstr(ParamLine,_to_upcase_str))>0) then
  help_file;
 if (Param_U='--HELP')
 or (pos(' --HELP ',__cvtstr(ParamLine,_to_upcase_str))>0) then
  Help;  {added 2001-01-22}
 DbFileName:=Param_o{U};
 FileName[NumberOfFiles]:=DbFileName;
 OpenFile;
 if NPar>1 then
     {after the file name, further parameters are present}
  if not dBase then
   begin                  {Provision for Ny being given after the file name
                           just 0 is functional (instead of /his)}
    val(Paramstr(2),Ny,i);
    if i=0 then if (Ny>=0) and (Ny<MaxYFields) then
     begin
      Posi_Par_before_cond:=2;
      if Ny=0 then JustHistogram:=true else Ny:=0;
     end
    else
     Ny:=0;
   end
  else
   if New_Positional_parameter then
    begin
     ParamUp(PPar); FieldX:=Param_U;
     for j:= 1 to DbNuField do
      if DbInfo[j].field = FieldX then Fx:=j;
     No_FieldX:= Fx=0;
     if not No_FieldX then Further:= New_Positional_parameter;
     if Further or No_FieldX then
                    {Y field(s) or conditions are given}
      begin
       ParamUp(PPar);
       val(Param_U,Ny,i);
       if (i=0) then   {number of Y-variables given}
        begin
         Further:=true;
         if Ny>0 then for j:= 1 to Ny do {reading names of Y field(s)}
          begin
           if Further and New_Positional_parameter then
            begin
             for k:= 1 to DbNuField do
              if DbInfo[k].field = ItemStrD(':',1,Param_U) then
               begin
                Fy[j]:=k;
                check_transf(Ny,aux_s);
               end;
             if Fy[j]=0 then
              begin
               dec(Posi_Par);
               Further:=false;
              end
             else inc(YNew)
            end
          end;
         Ny:=YNew;
        end
       else if not No_FieldX then
                        {just one Y given}
        begin
         for k:= 1 to DbNuField do
          if DbInfo[k].field = Param_U then Fy[1]:=k;
         if Fy[1]=0 then dec(Posi_Par)
         else begin Ny:=1; inc(YNew); end;
        end;
      end; {of Further or No_FieldX}
     Posi_Par_before_cond:=Posi_Par;
     Posi_Par:=1;
    end; {of if New_Positional_PArameter}
 PPar:=1;
 Conditions;
 if dBase then
  begin
   if not x_descr_set then
    if Fx>0 then
     x_descr:=DbInfo[Fx].field
    else
     x_descr:='NoR';
   if Ny>0 then
   for j:=1 to Ny do
    if not y_descr_set[j] then
     if Fy[j]>0 then
      y_descr[j]:=DbInfo[Fy[j]].field
     else
      y_descr[j]:='NoR';
  end;
 if title='nothing' then
  if GM_mode=2 then
   title:='Graph\_D '+ParamLine
  else
   title:='Graph_D '+ParamLine;
end;  {of Parameters}

procedure Histogram;
var Width_only_digit:byte;
begin {of Histogram branch}
 for j:= -30 to 30 do Count[j]:= 0;
 if NoForcedColons then
  begin
   Av:= 0.0; SD:= 0.0; Num:= 0;
   StartOfFile;
   NEnOfFi:= StartRecHis(NoR,Fx,x);
   writeln('Counting Average, Standard Deviation and Number of data');
   while Range do
    begin
     progress_report;
     if Filter and XP then
      begin
       inc(Num);
       Av:= Av + x;
       SD:= SD + sqr(x);
      end;
     inc(NoR);
     NEnOfFi:= NexRecHis(NoR,Fx,X);
    end; (*end of while loop - counting and summing data *)
   if not dBase then close(inp_text_f);
   if Num = 0 then
    begin
     writeln('No records within the given limits'); quit;
    end;
   Av:= Av / Num;
   SD:= sqrt (SD / Num - sqr (Av));
   if SD=0 then
    begin
     writeln('No histogram possible - SD zero; Av.=',Av,' Num=',Num);
     quit
    end;
   Margin:= trunc(exp(0.4*ln(Num)));
   if Margin > 30 then Margin:=30;
   Width:= SD * 2.5 / Margin ;
   if dbase and (DbInfo[Fx].typ ='N') then
                     {to avoid intervals less than least digit}
    if Width<Exp(L10*(-DbInfo[Fx].dec)) then
     width:= Exp(L10*(-DbInfo[Fx].dec));
   if not dBase then if rt_reset('',inp_text_f,DbFileName) then;
  end;
 To_Units:=Exp(L10*(-RoundUp(ln(Width)/L10 - 0.5)));
 Width_only_digit:=RoundUp(Width*To_units);
 if Width_only_digit>5 then
  begin
   To_Units:=To_Units/10;
   WIdth_only_digit:=1;
  end;
 Width:=Width_only_digit / To_units;
 if Av<0 then sig:=-1 else sig:=+1;
 Center:=(RoundUp(Av*To_units)-sig*(RoundUp(Av*to_units) mod Width_only_digit))
        /To_Units;
 StartOfFile;
 NEnOfFi:= StartRecHis(NoR,Fx,x);
 writeln('Counting the number of cases in each column');
 while Range do
  begin
   progress_report;
   if Filter and XP then
    begin
     j:= RoundUp((x-Center)/width);
     If j > Margin then j:= Margin;
     If j < -Margin then j:= -Margin;
     Count[j]:= Count[j] + 1
    end;
   inc(NoR);
   NEnOfFi:= NexRecHis(NoR,Fx,X);
  end; (*end of while loop - counting data in histogram boxes *)
 if not dBase then close(inp_text_f);
 if logarithmic then
  for j:=-Margin to Margin do
   case Count[j] of
    0: ;
    1: Count[j]:=100;
    else
      Count[j]:=RoundUp(1000*ln(Count[j])/l10);
   end;
 PlotHistogram; {Num,Av,SD,Margin,Width,Center,Count}

 if OutFileWanted then
  begin
   if dBase then
    write(OutFile,'Database file '+DbFilename,
     ',  histogram of '+x_descr+cl)
   else
    write(OutFile,'File '+DbFilename,
     ',  histogram of '+x_descr+cl);
   if NoForcedColons then
    write(OutFile,
    'Number of data    = ',Num,cl+
    'Average           =',SRx(4,Av),cl+
    'Standard Deviation=',SRx(1,SD),cl+
    'Width of Column   =',SRxs(0,Width),cl)
   else
    write(OutFile,
    'Forced center     =',SRx(4,Av),cl+
    'Width of Column   =',SRxs(0,Width),cl);
   write(OutFile,cl+'Center  Count'+cl);
   if DekExpX<>1 then
    write(OutFile,'/',SRx(0,DekExpX),cl);
   for j:= -Margin to margin do
    writeln(OutFile,(j*Width+Center)/DekExpX:6:0,Count[j]:5);
  end;

 if not BatchMode then
  begin
   GRAREAD(true,true,#0);
   PrintScrWanted;
   GRAREAD(true,true,#0);
  end;
 quit;
end; {of Histogram branch}

procedure Margins; {finding the extremes of data and setting margins to
                    the graph}
  var Places_origin_x:byte;
  begin
    StartOfFile;
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
      while Range do
       begin
        progress_report;
        if Filter and XP then
         begin
              if x>X_max then X_max:=x;
              if x<X_min then X_min:=x;
              FOR j:=1 to NY do
                  if YP[j] then
                     begin
                       if Y[j]>Y_max then Y_max:=Y[j];
                       if Y[j]<Y_min then Y_min:=Y[j]
                     end;
              inc(SNR);
         end;
        inc(NoR);
        NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
       end; {finding of margins}
    if not dBase then close(inp_text_f);
    if (SNR=0) or (Y_max<Y_min) then
     begin
      writeln(
'No records (meaningful or satisfying the filter) to plot a x--y graph!');
      quit
     end;
    if 7-trunc(ln(SNR)) > 0 then
     point_r:=7-trunc(ln(SNR))
    else
     point_r:=1; {had been :=0, probably an error}

    BaseX:=X_min;

    if Periodic then begin X_max:=1.25*Period; X_min:=-0.25*period end;
    X_max_min:=X_max-X_min;
    if X_max_min=0 then X_max_min:=1;
    if (abs(X_min)/X_max_min>10) and (not Origin_forced) then
     begin
      Places_origin_x:=trunc(ln(abs(X_min)/X_max_min)/l10)-1;
      Origin_X:=exp(l10*(Places_origin_x-int(ln(abs(X_min))/l10)));
      Origin_X:=int(X_min*Origin_x)/(Origin_x);
      if X_Min<0 then Origin_X:=-Origin_X;
      Origin_forced:=true;
      X_Min:=X_Min-Origin_X;
      X_Max:=X_Max-Origin_X;
      Origin_Str:=' - '+SRx(Places_origin_x,Origin_X)+')';
      LeftBr:='(';
     end;
    Y_max_min:=Y_max-Y_min; if Y_max_min=0 then Y_max_min:=1;
    if (abs(Y_min)/Y_max_min>10) and (not Origin_Y_forced) then
     begin
      Places_origin_x:=trunc(ln(abs(Y_min)/Y_max_min)/l10)-1;
      Origin_Y:=exp(l10*(Places_origin_x-int(ln(abs(Y_min))/l10)));
      Origin_Y:=int(Y_min*Origin_Y)/(Origin_Y);
      if Y_Min<0 then Origin_Y:=-Origin_Y;
      Origin_Y_forced:=true;
      Y_Min:=Y_Min-Origin_Y;
      Y_Max:=Y_Max-Origin_Y;
      Origin_Y_Str:=' - '+SRx(Places_origin_x,Origin_Y)+')';
      LeftBr_Y:='(';
     end;
    X_min:= X_min - (X_max_min)/30;
    X_max:= X_max + (X_max_min)/30;
    X_max_min:=X_max-X_min;
    Y_min:= Y_min - (Y_max_min)/30;
    Y_max:= Y_max + (Y_max_min)/30;
    Y_max_min:=Y_max-Y_min;
 end; {of setting Margins}

procedure Plot;
 begin
  FileNo:=1;
  while FileNo<=NumberOfFiles do
   begin
    if FileNo=1 then
     begin
      if not dBase then if rt_reset('',inp_text_f,DbFileName) then;
      gm_comm(cl+'% An initial plot of data:');
     end
    else
     begin
      if dBase then DbClose;
      DbFileName:=FileName[FileNo];
      OpenFile;
      gm_comm('Plot of file'+FileName[FileNo]+':');
     end;
    StartOfFile;
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
     while Range do
      begin
       if Filter and XP
       and
        ({(not Margins_set)
          or} ((X_min<x) and (x<X_Max)))
       then
        begin
         if Periodic then Periodize;
         sx:=gr_x(x);
         FOR j:=1 to NY do
          if YP[j]
           and ({(not Margins_set)
                or} ((Y_min<y[j]) and (y[j]<Y_Max)))
          then
           if LabelOnly then
            begin
             gm_outxy(sx,gr_y(Y[j]),__cvtstr(rec[LabField],_rem_white_str),
                'c',0);
            end
           else
            begin
             gm_circle_empty(sx,gr_y(Y[j]),point_r shl (5-j));
             if LabelWanted then
              gm_outxy(sx+(point_r shl 4)+32,gr_y(Y[j]),__cvtstr(rec[LabField],_rem_white_str),'l',0);
            end;
         if Periodic then {the second period}
          begin
           x:=x/period;
           if YP[1] then
            if (x<0.5) then
             begin
              if x>x_max_per then
               x_max_per:=x;
             end
            else
              if x-1<x_min_per then
               x_min_per:=x-1;
           if not ((x>0.25) and (x<0.75)) then
            begin
             if X<=0.25 then X:=X+1
             else if x>=0.75 then x:=x-1;
             sx:=gr_x(x*period);
             FOR j:=1 to NY do
             if YP[j] then
               gm_circle_full(sx,gr_y(Y[j]),16)
            end
          end;
        end;
       inc(NoR);
       NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
      end;
    inc(FileNo);
   end;
  if FileNo>1 then
   begin
    DbClose;
    DbFileName:=FileName[1];
    FileNo:=1;
    OpenFile;
   end;
  if not dBase then close(inp_text_f);
 end; {of initial Plot}

Procedure Regression_block;
var
 x_r,y_l,x_l:word;
 convers,hide_menu:pointer;
 restore_scr,hiding:boolean;
 Departure,X_sym,X_max_old,X_min_old,X_symN,SDX_sym,YD_abs_30:real;
 PosX:byte;  {For Mirror option: 0 for X<X_sym, 1 for X=>X_sym}
 Stat: array [0..1] of record
   NDep,NDepSh:word;
   WDepSh,SDep,SQDep,SShift,SQShift,Ztest:real;
 end;
const
 x_left=40;y_up=40; li1:longint=1;
 LMarGiven:boolean=false; RMarGiven:boolean=false;
 HIdden_menu:boolean=false;

 procedure Try_menu(x_pc,y_pc:word);
  begin
   if restore_scr then
    begin
     if x_pc in [10..99] then
      x_pc:=(x_r*x_pc) div 100
     else x_pc:=x_r;
     if y_pc in [10..99] then
      y_pc:=(y_l*y_pc) div 100
     else y_pc:=y_l;
     getimage   (x_left,y_up,x_left+x_pc-1,y_up+y_pc-1,convers^);
     setviewport(x_left,y_up,x_left+x_pc-1,y_up+y_pc-1,ClipOn);
     clearviewport;
     rectangle(1,1,pred(x_pc),pred(y_pc));
     Ycoord:=5;
     Hidden_menu:=false;
    end;
  end;
 procedure Wipe_menu;
  begin
   if restore_scr then
    begin
     clearviewport;
     setviewport(0,0,getmaxX,getmaxy,clipon);
     putimage(x_left,y_up,convers^,NormalPut);
     Hidden_menu:=false;
    end;
  end;
 function NumVal(var NV:real):boolean;
  begin
   if resp>' ' then
    begin
     val(resp,NV,J);
     if J>0 then halt;
     NumVal:=true;
    end
   else
    NumVal:=false;
  end;
 procedure GraRead_menu;
  var R:char;
  begin
   repeat
    R:=readkey;
    if R=#0 then
     begin
      R:=readkey;
      if {(R=#61) and} hiding then
       if Hidden_menu then
        begin
         putimage(0,0,hide_menu^,NormalPut);
         Hidden_menu:=false;
        end
       else
        begin
         getimage(0,0,x_r,y_l,hide_menu^);
         putimage(0,0,convers^,NormalPut);
         Hidden_menu:=true;
        end;
      R:=#0
     end;
   until R<>#0;
   graread(false,false,R);
  end;
  Procedure MirrorTransf;
   begin
    if Mirror then
     begin
      X:=X-X_sym;
      if Periodic then if X>=HalfPeriod then x:=x-period
                  else if X<-HalfPeriod then x:=x+period;
      if X<0 then PosX:=0 else PosX:=1;
      X:=abs(X);
     end
   end;

begin {of Regression_block}
 if Periodic and Mirror then
  begin
   if x_max_per<0.3 then
    X_Max:=  x_max_per*period;
   if x_min_per>-0.3 then
    X_Min:=  x_min_per*period;
   X_max_min:=X_max-X_min;
   X_min:= X_min - (X_max_min)/30;
   X_max:= X_max + (X_max_min)/30;
   X_max_min:=X_max-X_min;
  end;
 LMar:= X_min; RMar:=X_max; PolDegree:=1; Ycoord:=5;
 X_max_old:=X_Max; X_min_old:=X_min;
 x_r:=GetMaxX div 2;
 y_l:=getmaxY div 8;
 if x_r*y_l*li1<65535 then
  if MaxAvail>ImageSize(1,1,x_r,y_l) then
   begin
    restore_scr:=true;
    getmem(convers,ImageSize(1,1,x_r,y_l));
   end
  else
   restore_scr:=false
 else
  restore_scr:=false;
 if restore_scr then
  begin
   x_l:=5;
   if MaxAvail>ImageSize(1,1,x_r,y_l) then
    begin
     hiding:=true;
     getmem(hide_menu,ImageSize(1,1,x_r,y_l));
    end
   else
    hiding:=false
  end
 else
  begin
   x_l:=45;
   hiding:=false;
  end;
 repeat
  moveto(x_l,Ycoord);
  if Mirror then
   begin
    if FirstTime then
     begin
      FirstTime:=false;
      Try_menu(80,38);
      moveto(x_l,Ycoord); inc(Ycoord,10);
      outtext('Guess the phase of the symmetry axis: ');
      GraRead_menu;
      if not NumVal(X_sym) then X_sym:=X_min+(X_Max-X_Min)/2;
      Wipe_menu;
      gm_close;
      GM_mode:=GM_mode_true;  {next screen will be copied to a graphic file}
     end
    else
     begin
      X_sym:=X_symN;
      gm_close;
     end;
    if X_sym-X_min_old>X_Max_old-X_sym then X_Max:=X_sym-X_min_old
    else X_Max:=X_Max_old - X_sym;
    X_Min:=0;
    X_max_min:=X_max-X_min;
    if not LMarGiven then LMar:=X_min;
    if not RMarGiven then RMar:=X_max;
    X_min:= X_min - (X_max_min)/30;
    X_max:= X_max + (X_max_min)/30;
    X_max_min:=X_max-X_min;

    gm_init(XS,YS);
    if y_descr_set[1]=true then gr_div_str_y:='-';
    if x_descr_set   =true then gr_div_str_x:='-';
    gr_frame('mirrored around'+SRx(3,X_sym),
              x_descr,
              y_descr[1]);
    if Ny>1 then  {more Y variables -> their names to the Y axis}
     begin
      gm_comm(cl+'% Description of further Y-variables:');
      for j:= 2 to Ny do
       gm_outxy(gr_left-TextH,gr_top-RoundUp(j*0.7*TextH),
        y_descr[j],'l',0)
     end;

    gm_comm(cl+'% Data points:');
    if not dBase then  if rt_reset('',inp_text_f,DbFileName) then;
    StartOfFile;
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
      while Range do
       begin
        if Filter and XP and YP[1] then
         begin
          if Periodic then Periodize;
          MirrorTransf;
          sx:=gr_x(x);
          FOR j:=1 to NY do
           if YP[j] then
            begin
             if PosX=0 then
              gm_line(sx-point_r shl 3,gr_y(Y[j]),sx+point_r shl 3,gr_y(Y[j]));
             if LabelOnly then
              begin
               gm_outxy(sx,gr_y(Y[j]),__cvtstr(rec[LabField],_rem_white_str),'c',0);
              end
             else
              begin
               gm_circle_empty(sx,gr_y(Y[j]),point_r shl 4);
               if LabelWanted then
                gm_outxy(sx+(point_r shl 4)+32,gr_y(Y[j]),__cvtstr(rec[LabField],_rem_white_str),'l',0);
              end;
            end;
         end;
        inc(NoR);
        NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
       end; {plotting }
    if not dBase then close(inp_text_f);
    moveto(x_l,Ycoord); inc(Ycoord,10);
   end;
  if LMarGiven then gm_line(gr_x(LMar),gr_y(Y_Max),gr_x(LMar),gr_y(Y_Min));
  if RMarGiven then gm_line(gr_x(RMar),gr_y(Y_Max),gr_x(RMar),gr_y(Y_Min));
  Try_menu(100,75); if not restore_scr then Ycoord:=5;
  moveto(x_l,Ycoord); inc(Ycoord,10);
  outtext('Ev. left margin for regression >'+SRx(3,LMar)+' : ');
  GraRead_menu;
  if Numval(LMar) then
   if (LMar>X_min) and (LMar< RMar) then
    LMarGiven:=true
   else
    LMar:=X_min;
  moveto(x_l,Ycoord); inc(Ycoord,10);
  outtext('Ev. right margin <'+SRx(3,RMar)+' : ');
  GraRead_menu;
  if Numval(RMar) then
   if (RMar<X_max) and (RMar>LMar) then
    RMarGiven:=true
   else
    RMar:=X_max;
  moveto(x_l,Ycoord); inc(Ycoord,10);
  outtext('Ev. degree of polynome >'+SI(4,PolDegree)+' : ');
  GraRead_menu;
  if resp>' ' then
   begin
    val(resp,PolDegree,J);
    if J>0 then quit
   end;
  reginit(PolDegree);

  incr := (RMar - Lmar)/200;
  if not Origin_forced then
   if (RMar-LMar)< LMar then Zero_X:=LMar
   else Zero_X:=0;
  if not dBase then  if rt_reset('',inp_text_f,DbFileName) then;
  StartOfFile;
  NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
  while Range {NEnOfFi and (NoR<=StN+Number)} do
   begin
    if Filter and XP and YP[1] then
     begin
      if Periodic then Periodize;
      MirrorTransf;
      if (LMar<= X) AND (X<=RMar) then regenter(x-Zero_X,y[1])
     end;
    inc(NoR);
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
   end; {of preparing the coefficients}
  if not dBase then close(inp_text_f);

  if not regcompute then gm_quit;
  Wipe_menu;
  gm_comm('The regression curve:');
  x:=X_min;
  Stat[0].NDep:=0;
  YD_abs_30:=0;
  repeat
   for j:=1 to degree_plus_1 do yy:=RegValue(x-Zero_x,yd);
   if (Y_Max>=yy) and (yy>=Y_min) then
    gm_circle_full(gr_x(x),gr_y(yy),10);
   if (x>LMar) and (x<RMar) then
    begin
     YD_abs_30:=YD_abs_30+abs(yd);
     inc(Stat[0].NDep)
    end;
   x:=x+incr;
  until x>X_max;
  YD_abs_30:=YD_abs_30*30/(100*Stat[0].NDep);

  if Mirror then {proposing a shift of X_sym}
   begin
    for PosX:=0 to 1 do with Stat[PosX] do
     begin
      NDep:=0;
      NDepSh:=0;
      WDepSh:=0;
      SQDep:=0;
      SDep:=0;
      SShift:=0;
      SQShift:=0;
     end;
    if not dBase then  if rt_reset('',inp_text_f,DbFileName) then;
    StartOfFile;
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
    while Range {NEnOfFi and (NoR<=StN+Number)} do
     begin
      if Filter and XP and YP[1] then
       begin
        if Periodic then Periodize;
        MirrorTransf;
        if (LMar<= X) AND (X <= RMar) then
         begin
          aux_r:=regvalue(x-Zero_x,yd);
          with Stat[PosX] do
           begin
             Departure:=y[1]-aux_r;
             inc(NDep);
             SDep:=SDep+Departure;
             SQDep:=SQDep+Departure*Departure;
             if weight_shift then
              begin
               if abs(yd)>YD_abs_30 then inc(NDepSh);
               aux_r:=sqr(yd);
               WDepSh:=WDepSh+aux_r;
               SShift:=SShift+Departure*yd;
               {SQShift:=SQShift+sqr(Departure)*aux_r}
              end
             else if abs(yd)>YD_abs_30 then
              begin
               inc(NDepSh);
               SShift:=SShift+Departure/yd;
               SQShift:=SQShift+sqr(Departure)/sqr(yd)
              end
           end;
         end
       end;
      inc(NoR);
      NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
     end; {of summing the departures}
    if not dBase then close(inp_text_f);
    Try_menu(100,95);
    moveto(x_l,Ycoord); inc(Ycoord,10);
    outtext('Shift left  Z   shift  right  Z');
    moveto(x_l,Ycoord); inc(Ycoord,10);
    for PosX:=0 to 1 do with Stat[PosX] do
     begin
      SQDep:=sqrt((SQDep-SDep*SDep/NDep)/(NDep-1));
      SDep:=SDep/NDep;
      if not weight_shift then
       begin
        SQShift:=sqrt((SQShift-SShift*SShift/NDepSh)/(NDepSh-1));
        SShift:=SShift/NDepSh;
        Ztest:=abs(SShift)*sqrt(NDepSh)/SQShift;
       end
      else
       begin
        SQShift:=SQDep*sqrt(NDep/WDepSh);
        SShift:=SShift/WDepSh;
        Ztest:=abs(SShift)*sqrt(NDep)/SQShift;
       end;
      outtext(SRx(3,SShift)+' '+SRx(1,Ztest)); moveto(100+x_l,Ycoord)
     end;
    inc(Ycoord,10);
    X_symN:=X_sym+(Stat[0].SShift-Stat[1].SShift)/2;
 {Confidence interval for X_sym now:}
    aux_r:=0; Num:=0;
    for PosX:=0 to 1 do with Stat[PosX] do
     begin
      aux_r:=aux_r+sqr(SQShift)*(NDepSh-1);
      inc(Num,NDepSh)
     end;
   { SDX_sym:=sqrt((aux_r)/((Num)*(Num-1-degree_plus_1)));}
    SDX_sym:=sqrt(aux_r/(Num-1-degree_plus_1))
             * 0.5 *
             sqrt((1/Stat[0].NDepSh) + (1/Stat[0].NDepSh))
   end;

  moveto(x_l,Ycoord); inc(Ycoord,10);
  if Mirror then
   outtext('Old X_sym='+SRx(3,X_sym)+'; should be tried '
             +SRx(3,X_symN)+' ? (y/N):')
  else
   begin
    Try_menu(45,38); if restore_scr then moveto(x_l,Ycoord); inc(Ycoord,10);
    outtext('Once more? (y/N): ');
   end;
  GraRead_menu;
  Wipe_menu;
  PrintScrWanted;
 until not ((resp='y') or (resp='Y') or (resp='z') or (resp='Z'));

 if OutFileWanted then
  begin
   writeln(OutFile,'The regression results of the task: '+cl2,

   '  Graph_d '+ParamLine+cl2,

   'left margin: ',SRx(2,LMar),' , right margin: ',SRx(2,RMar),cl);
   if Origin_Y_forced then
    writeln(OutFile,y_descr[1]+copy(Origin_Y_Str,1,length(Origin_Y_Str)-1),' was computed'+cl);
   if (Zero_X=0) and (not Origin_forced) then
    writeln(OutFile,
'coefficients of the polynome - from power zero to ',degree_plus_1-1,' :')
   else
    if Origin_forced then
     writeln(OutFile,
'coefficients of the polynome of (X'+Origin_str+' - from power zero to ',degree_plus_1-1,' :')
    else
     writeln(OutFile,
'coefficients of the polynome of (X-',SRx(4,Zero_X),'), from power zero to ',degree_plus_1-1,' :');
   for i:= 1 to degree_plus_1 do writeln(OutFile,SRx(3,polynome_coeffs[i]));

   if Mirror then
    writeln(OutFile,cl,
      'symmetry axis at ',SRx(4,X_sym),' with SD of ',SRx(1,SDX_sym),cl2,
      SRx(1,Stat[0].SQDep),' / ',SRx(1,Stat[1].SQDep),
        '    is the Standard deviation of the left/right branch',cl,
      Stat[0].NDep:4,'  / ',Stat[1].NDep:4,
        '  are the numbers of points at the left/right branch',cl,
      Stat[0].NDepSh:4,'  / ',Stat[1].NDepSh:4,
        '  are the   -    "    -     with abs(derivation) > 30 % of average',cl,
      SRx(1,Stat[0].ZTest),' / ',SRx(1,Stat[1].Ztest),
        '    are the Z-tests of zero shifts at the left/right branch');
   writeln(OutFile);
  end;

 if dBase and (Departures or Comp_Y or DeparturesX or Derivation) then
 begin

  if departures then
   if DbInfo[DepField].typ='C' then {find standard deviation to guess
                                    a suitable number of decimal places}
      { but there is no such comfort for the remaining 3 fields! }
    begin
     with Stat[0] do
       begin
        NDep:=0;
        SQDep:=0;
        SDep:=0;
       end;
     StartOfFile;
     NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
     while Range {NEnOfFi and (NoR<=StN+Number)} do
     begin
      if Filter and XP and YP[1] then
       begin
        if Periodic then Periodize;
        MirrorTransf;
        if (LMar<= X) AND (X <= RMar) then
         begin
          aux_r:=regvalue(x-Zero_X,yd);
          with Stat[0] do
           begin
             Departure:=y[1]-aux_r;
             inc(NDep);
             SDep:=SDep+Departure;
             SQDep:=SQDep+Departure*Departure;
           end;
         end
       end;
      inc(NoR);
      NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
     end; {of summing the departures}
     with Stat[0] do
     begin
      SQDep:=sqrt((SQDep-SDep*SDep/NDep)/(NDep-1));
      if OutFileWanted then writeln(OutFile,
       'standard deviation of departures is '+SRx(2,SQDep));
      if SQDep<10 then
       begin
        DbInfo[DepField].dec:=trunc(-ln(SQDep)/L10)+1;
        if SQDep<1 then inc(DbInfo[DepField].dec);
        if DbInfo[DepField].dec >DbInfo[DepField].len-3 then
          if DbInfo[DepField].len>2 then
           DbInfo[DepField].dec:=DbInfo[DepField].len-3
          else
           DbInfo[DepField].dec:=0
       end
     end
    end;
  StartOfFile;
  NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
  while Range {NEnOfFi and (NoR<=StN+Number)} do
   begin
    if (Filter or WriteForAll) and XP and YP[1] then
     begin
      if Periodic then Periodize;
      MirrorTransf;
      if (LMar<= X) AND (X <= RMar) then
       begin
        aux_r:=regvalue(x-Zero_x,yd);
        if Departures then
          DbWrNum(DepField,y[1]-aux_r);
        if DeparturesX then
          if PosX=0 then
           DbWrNum(DepXField,(y[1]-aux_r)/yd)
          else
           DbWrNum(DepXField,-(y[1]-aux_r)/yd);
        if Comp_Y then  DbWrNum(Comp_Y_Field,aux_r);
        if Derivation then  DbWrNum(Deriv_Field,yd)
       end
      else
       begin
        if Departures then rec[DepField]:='';
        if DeparturesX then rec[DepXField]:='';
        if (Comp_y or Derivation) then
         begin
          aux_r:=regvalue(x-Zero_x,yd);
          if Comp_Y then DbWrNum(Comp_Y_Field,aux_r);
          if Derivation then DbWrNum(Deriv_Field,yd)
         end
       end;
     end;
    xp:=DbWrite(NoR,Rec);
    inc(NoR);
    NEnOfFi:= NexRecPlot {NoR,Fx,Fy,X,Y} ;
   end; {of writing the departures}
 end; {of If WriteRegressionToDbf}

end; {of Regression_block}

 procedure get_y_descr(j_y:byte);
  begin
   if y_descr_set[j_y] then exit;
   Ylstr:=LeftBr_Y;
   Yrstr:=Origin_y_str;
   if YTrans[j_y] then
    begin
     if (YAddiStr[j_y]<>'') then
      if LeftBr_Y='' then
       begin
        Ylstr:='(';
        Yrstr:=YAddiStr[j_y]+')';
       end
      else
       Yrstr:=YAddiStr[j_y]+Yrstr;
    end;
   y_descr[j_y]:=Ylstr+y_descr[j_y]+Yrstr+YcoefStr[j_y]+gr_div_str_y;
  end;


{Main program - plotting a histogram OR A GRAPH from a .dbf}



begin
gray16_stars:=false;  {to avoid setting of a gray palette in
                      gm_init of graph_m* unit}

NPar:= ParamCount;
if NPar > 0 then Parameters   {parameters are present}
else help;
if not Margins_set then
 begin
  X_max:=-6E37; {initialization of limits of X an Y}
  X_min:= 6E37;
  Y_min:= 6E37;
  Y_max:=-6E37;
 end;
if JustHistogram
or (dBase and (Ny=0))
 then Histogram  {Histogram branch which has an end of its own.}
else
 begin {of the Plot branch}
  if Ny=0 then Ny:=1;
  if not Margins_set then Margins;
  if Mirror then
   begin
    GM_mode_true:=GM_mode;
    GM_mode:=0
   end;
  gm_init(XS,YS);
  if not x_descr_set then
   x_descr:=LeftBr+x_descr+Origin_str
  else
   gr_div_str_x:='-';
  get_y_descr(1);
  if y_descr_set[1]=true then gr_div_str_y:='-';
  if NumberOfFiles>1 then
   for i:=1 to NumberOfFiles-1 do
    if YTrans[i+MaxYFields] then
     begin
      MoreYAxes:= true;
      inc(NumFYAxes);
      AYCoef[i]:=YCoef[i+MaxYFields];
      AYAddi[i]:=YAddi[i+MaxYFields];
     end;
  gr_frame(title,
              x_descr,
              y_descr[1]);
  if Ny>1 then  {more Y variables -> their names to the Y axis}
   begin
    gm_comm(cl+'% Description of further Y-variables:');
    for j:= 2 to Ny do
     begin
      get_y_descr(j);
      gm_outxy(gr_left-TextH,gr_top-RoundUp(j*0.7*TextH),
        y_descr[j],'l',0)
     end;
   end;
  Plot;
  if regression then Regression_block
  else
   if not BatchMode then
    begin
     GRAREAD(true,true,#0);
     PrintScrWanted;
     GRAREAD(true,true,#0);
    end;
  quit
 end; {of the Plot branch and whole operation};
end.
