 {~ A check digit of an International Standard Book Number ~}

program ISBN; { by Jan Hollan. Computes the check digit
                from the left 9 digits of the (ten-digit) ISBN
               }
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)
uses angles_o, {enabling easy and reliable text file reset and rewrite}
     DbBridge, un_str_m;

const
cl=#13#10;
h05=cl+
'Program ISBN computes a check digit of an International Standard Book Number'+cl+
'or checks those digits (i.e., validity of ISBNs) in a dBase file.'+cl+cl;

h1=
'If a string given on the command line represents an ISBN,' +cl+
'then the programme will give the check number computed from the nine'+cl+
'left digits of the number.'+cl+
                             cl+
'A string can contain any non-digit characters in it.'+cl
                            +cl;
h2=
'If the first character of a string is @, then the rest is interpreted'+cl+
'as a name of the file:'+cl+cl+

'If it is a dBase file, check of field ISBN is made.'+cl+cl;

h3=
'Otherwise the (text) file is assumed to contain ISBN at its beginning.'+cl+
'Then a file >>isbn_chd.tmp<< is created, which contains just the check digit'+cl+
'(this is meant for use in a macro of your editor).'+cl+
              cl;
h4=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

isbnstr:string[50]='';

var
 n  : array [0..50] of byte absolute isbnstr;
 isbn_f_n:byte;
 i:byte;
 dig:byte;
 dic:string[1];
 isbnfile:text;
const
 sum:word=0;
 j:byte=0;
 makefil:boolean=false;
 NoR:word=1;


procedure help;
begin
 write(h05,h1,h2,h3,h4);
 halt;
end;

begin
 if paramcount<1 then halt;
 for i:=1 to paramcount do ISBNstr:=isbnstr+paramstr(i);
 if ISBNstr[1]='@' then
 if DbInit(copy(isbnstr,2,n[0]-1)) then
  begin
   isbn_f_n:= DbFieldNum('isbn');
   if isbn_f_n=0 then help{('Sorry, there is no field ISBN in the file '+
       copy(isbnstr,2,n[0]-1+'!')};
   while DbRead(NoR,rec) do
    begin
     isbnstr:=__cvtstr(rec[isbn_f_n],_rem_white_str);
     if isbnstr<>'' then
      begin
       j:=0;
       sum:=0;
       for i:=0 to 8 do
        begin
         inc(j);
         while not (n[j] in [48..57]) do
          if j<20 then begin if isbnstr[j]='?' then help else inc(j) end
          else halt;
         inc(sum,(10-i)*(n[j]-48));
        end;
       dig:=(11 - (sum mod 11)) mod 11;
       if dig < 10 then str(dig,dic) else dic:='X';
       inc(j);
       if not (isbnstr[j] in ['0'..'9','X']) then inc(j);
       if not (isbnstr[j]=dic) then
        begin
         writeln(
'record ',NoR,' has non-valid ISBN: the correct check digit would be:  '+dic+',',cl,
'                           but the number reads ',isbnstr);
         DbDisp(NoR);
        end;
      end;
     inc(NoR);
    end;
   writeln('Checking of dBase file finished');
   DbClose;
  end
 else
   begin
   if not rt_reset('',isbnfile,copy(isbnstr,2,n[0]-1)) then help;
   readln(isbnfile,isbnstr);
   close(isbnfile);
   if rt_rewrite(isbnfile,'isbn_chd.tmp') then makefil:=true;
  end;
 for i:=0 to 8 do
  begin
   inc(j);
   while not (n[j] in [48..57]) do
    if j<20 then begin if isbnstr[j]='?' then help else inc(j) end
    else halt;
   inc(sum,(10-i)*(n[j]-48));
  end;
 dig:=(11 - (sum mod 11)) mod 11;
 if dig < 10 then str(dig,dic) else dic:='X';
 writeln(dic);
 if makefil then
  begin
   write(isbnfile,dic);
   close(isbnfile);
  end;
end.
