 {~ dry and wet temperature to humidity ~}

   { Has to be converted to the appropriate code page;
   the original one is 'Kamenicky'
  -- this is just because of a character denoting a degree}

program psychro; {a sketch by Jan Hollan}

{The regression results of the task:

  Graph_d wv.dbf degc 1 lgpcm ina degc 0 40 out wv_plo2.reg reg dep dep

left margin: -0.967 , right margin:  30.0

coefficients of the polynome - from power zero to 2 :
 2.285
 0.09856
-3.568E-4

standard deviation of departures is  0.00400

  ---------------------
  Graph_d vw.dbf lgpcm 1 degc ina degc 0 40 out wv_plo3.reg reg dep dep

left margin:  2.19 , right margin:  4.93

coefficients of the polynome - from power zero to 2 :
-20.06
 7.609
 0.5188

standard deviation of departures is  0.0401

 }
const cl=#13#10;
var wt,dt,difft,relhum,absdt:real; j:integer;

procedure help;
begin
writeln(cl,
'Psychro <dry sensor Celsius temperature> <wet sensor temperature>',
 cl,cl,
'  (The temperatures should be within 0 and 30 degrees Celsius.)',cl,
 cl,
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
halt
end;

function gpcm(t:real):real;
begin
 gpcm:=exp(ln(2)*(2.285+t*(0.09856-t*3.568E-4)))
end;

function cond_temp(g:real):real;
begin
 g:=ln(g)/ln(2);
 cond_temp:=-20.06+g*(7.609+g*0.5188);
end;

procedure res_line(coeff:real;moving:string);
 begin
  relhum:=(wt-coeff*difft*288/absdt)/dt;
  writeln(100*relhum:2:0,' %  (', dt*relhum:5:1,' g.m-3,',
   cond_temp(dt*relhum):5:1,' C )  -- ',moving);
 end;

begin
if paramcount<2 then help;
val(paramstr(1),dt,j);
val(paramstr(2),wt,j);
if (dt<0) or (dt>30) then help;
if (wt<0) or (wt>30) then help;
writeln;
writeln(dt:4:1,wt:6:1,
'  : Celsius temperatures of the dry and wet sensor / 1 K');
writeln;
difft:=dt-wt; absdt:=dt+273;
dt:=gpcm(dt);
wt:=gpcm(wt);
writeln(dt:4:1,wt:6:1,
'  : maximum absolute humidities at these temperatures / 1 g.m-3');
writeln;
writeln(
         'The computed values for the air around the wet sensor:',cl,cl,
'relative humidities',cl,
'      ( absolute humidities',cl,
'                    condensation temperatures )',cl);
res_line(0.89,'still air');
res_line(0.59,'moving air');
res_line(0.49,'blowing air');
end.
