 {~ relative humidity and Celsius temperature to Humidity Absolute ~}

   { Has to be converted to the appropriate code page;
   the original one is 'Kamenicky'
  -- this is just because of a character denoting a degree}

program rel2abs; {a sketch by Jan Hollan}

{The regression results of the task:

  Graph_d wv.dbf degc 1 lgpcm ina degc 0 40 out wv_plo2.reg reg dep dep

left margin: -0.967 , right margin:  30.0

coefficients of the polynome - from power zero to 2 :
 2.285
 0.09856
-3.568E-4

standard deviation of departures is  0.00400

  ---------------------
  Graph_d vw.dbf lgpcm 1 degc ina degc 0 40 out wv_plo3.reg reg dep dep

left margin:  2.19 , right margin:  4.93

coefficients of the polynome - from power zero to 2 :
-20.06
 7.609
 0.5188

standard deviation of departures is  0.0401

 }
const cl=#13#10;

var wt,dt,difft,relhum,absdt:real; j:integer;

procedure help;
begin
writeln(cl,'<relative humidity / 1 %>  <Celsius temperature / 1 K>',cl);
writeln(' are the parameters of this Humidity Absolute  (Rel2Abs)  programme.');
writeln(' (The temperatures should be within 0 and 30 degrees Celsius.)',
 cl,cl,
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);

halt
end;

function gpcm(t:real):real;
begin
 gpcm:=exp(ln(2)*(2.285+t*(0.09856-t*3.568E-4)))
end;

function cond_temp(g:real):real;
begin
 g:=ln(g)/ln(2);
 cond_temp:=-20.06+g*(7.609+g*0.5188);
end;

begin
if paramcount<2 then help;
val(paramstr(1),relhum,j);
val(paramstr(2),dt,j);
if (dt<0) or (dt>30) then help;
if (relhum<0) or (relhum>100) then help;
writeln;
writeln(
'relative humidity is', relhum:6:1,
' %, Celsius temperature is',dt:6:1,' C');
writeln;
dt:=gpcm(dt);
writeln(
'absolute humidity is',dt*relhum/100:6:1,
' g/m3,  maximum  woud be',dt:6:1,' g/m3',cl);
writeln(
'condensation temperature is',cond_temp(dt*relhum/100):6:1,' C',cl);
end.
